# $SiLK: build.mk 7467 2007-06-11 14:17:29Z mthomas $

# Local rules

clean-local: clean-remove-man


# Rules to build (and clean) the manual pages (troff) from the Perl
# POD (Plain Old Documentation) source files
#
POD2MAN_ARGS = --center="SiLK Tool Suite" --release="$(PACKAGE_STRING)"

.pod.man:
	$(POD2MAN) $(POD2MAN_ARGS) $< > $@

clean-remove-man:
	$(RM) -f *.man


# Rules to install the .conf files into $(prefix)/share/silk/etc/
#
conf_file_dir = $(pkgdatadir)/etc

install-conf-files: $(conf_files)
	@$(NORMAL_INSTALL)
	$(mkinstalldirs) $(DESTDIR)$(conf_file_dir)
	@list='$(conf_files)'; for p in $$list; do \
	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
	  f="`echo $$p | sed -e 's,^.*/,,;$(transform)'`"; \
	  echo " $(INSTALL_DATA) $$d$$p $(DESTDIR)$(conf_file_dir)/$$f"; \
	  $(INSTALL_DATA) $$d$$p $(DESTDIR)$(conf_file_dir)/$$f; \
	done

uninstall-conf-files:
	@$(NORMAL_UNINSTALL)
	@list='$(conf_files)'; for p in $$list; do \
	  f="`echo $$p | sed -e 's,^.*/,,;$(transform)'`"; \
	  echo " rm -f $(DESTDIR)$(conf_file_dir)/$$f"; \
	  rm -f $(DESTDIR)$(conf_file_dir)/$$f; \
	done


# Rules to install the .init.d files into $(prefix)/share/silk/etc/init.d/
#
init_d_scripts_dir = $(pkgdatadir)/etc/init.d

install-init-d-scripts: $(init_d_scripts)
	@$(NORMAL_INSTALL)
	$(mkinstalldirs) $(DESTDIR)$(init_d_scripts_dir)
	@list='$(init_d_scripts)'; for p in $$list; do \
	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
	  f="`echo $$p | sed -e 's,^.*/,,;s,\.init\.d$$,,;$(transform)'`"; \
	  echo " $(INSTALL_SCRIPT) $$d$$p $(DESTDIR)$(init_d_scripts_dir)/$$f"; \
	  $(INSTALL_SCRIPT) $$d$$p $(DESTDIR)$(init_d_scripts_dir)/$$f; \
	done

uninstall-init-d-scripts:
	@$(NORMAL_UNINSTALL)
	@list='$(init_d_scripts)'; for p in $$list; do \
	  f="`echo $$p | sed -e 's,^.*/,,;s,\.init\.d$$,,;$(transform)'`"; \
	  echo " rm -f $(DESTDIR)$(init_d_scripts_dir)/$$f"; \
	  rm -f $(DESTDIR)$(init_d_scripts_dir)/$$f; \
	done

