
/*  A Bison parser, made from /Users/mthomas/.tmp/silktools-0.11.2/src/libflowsource/probeconfparse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ACCEPT_FROM_HOST_T	257
#define	CLASS_T	258
#define	COMMA	259
#define	EOL	260
#define	ISP_IP_T	261
#define	LISTEN_AS_HOST_T	262
#define	LISTEN_ON_PORT_T	263
#define	LISTEN_ON_USOCKET_T	264
#define	LOG_FLAGS_T	265
#define	PRIORITY_T	266
#define	PROBE_NAME_T	267
#define	PROBE_TYPE_T	268
#define	PROTOCOL_T	269
#define	READ_FROM_FILE_T	270
#define	POLL_DIRECTORY_T	271
#define	REMAINDER_T	272
#define	SENSOR_PROBE_T	273
#define	SENSOR_T	274
#define	ID	275
#define	INTERFACE	276
#define	IPBLOCK	277

#line 1 "probeconfparse.y"

/*
** Copyright (C) 2005-2007 by Carnegie Mellon University.
**
** @OPENSOURCE_HEADER_START@
** 
** Use of the SILK system and related source code is subject to the terms 
** of the following licenses:
** 
** GNU Public License (GPL) Rights pursuant to Version 2, June 1991
** Government Purpose License Rights (GPLR) pursuant to DFARS 252.225-7013
** 
** NO WARRANTY
** 
** ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER 
** PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON UNIVERSITY 
** PURSUANT TO THIS LICENSE (HEREINAFTER THE "DELIVERABLES") ARE ON AN 
** "AS-IS" BASIS. CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY 
** KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT 
** LIMITED TO, WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABILITY, INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE 
** OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT, 
** SPECIAL OR CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY 
** TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE, REGARDLESS OF 
** WHETHER SUCH PARTY WAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES. 
** LICENSEE AGREES THAT IT WILL NOT MAKE ANY WARRANTY ON BEHALF OF 
** CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON 
** CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED WITH THE 
** DELIVERABLES UNDER THIS LICENSE.
** 
** Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie 
** Mellon University, its trustees, officers, employees, and agents from 
** all claims or demands made against them (and any related losses, 
** expenses, or attorney's fees) arising out of, or relating to Licensee's 
** and/or its sub licensees' negligent use or willful misuse of or 
** negligent conduct or willful misconduct regarding the Software, 
** facilities, or other rights or assistance granted by Carnegie Mellon 
** University under this License, including, but not limited to, any 
** claims of product liability, personal injury, death, damage to 
** property, or violation of any laws or regulations.
** 
** Carnegie Mellon University Software Engineering Institute authored 
** documents are sponsored by the U.S. Department of Defense under 
** Contract F19628-00-C-0003. Carnegie Mellon University retains 
** copyrights in all material produced under this contract. The U.S. 
** Government retains a non-exclusive, royalty-free license to publish or 
** reproduce these documents, or allow others to do so, for U.S. 
** Government purposes only pursuant to the copyright license under the 
** contract clause at 252.227.7013.
** 
** @OPENSOURCE_HEADER_END@
*/

/*
**  Parser for probe configuration file
**
*/

#define DECLARE_IFMAP_VARIABLES 1
#include "silk.h"

RCSIDENT("$SiLK: probeconfparse.y 6821 2007-04-06 16:20:51Z mthomas $");

#include "probeconf.h"
#include "probeconfscan.h"
#include "silk_site.h"
#include "sksite.h"
#include "libflowsource.h"


/* LOCAL DEFINES AND TYPEDEFS */

/* Set DEBUG to 1 to enable debugging printf messasges, 0 otherwise.
 * Generally best to leave this commented out so gcc -DDEBUG=1 will
 * work */
/* #define DEBUG 1 */

/* Verify DEBUG is set */
#ifndef DEBUG
#  define DEBUG 0
#endif

/* For printing messages when DEBUG is non-zero.  Use as:
 *    DEBUG_PRINTF(("x is %d\n", x));
 * Note ((double parens)) */
#if DEBUG
#  define DEBUG_PRINTF(x) printf x
#else
#  define DEBUG_PRINTF(x)
#endif


/* magic value used to denote that a uint16_t---which are stored in
 * uint32_t's in the parser---has not yet been given a value. */
#define UINT16_NO_VALUE  0x10000  /* 0xFFFF + 1 */

/* to avoid repeatedly creating and destroying number lists, we keep a
 * pool of free number_lists.  this is the size of the pool. */
#define NUMBER_LIST_POOL_CAPACITY  16

/* as NUMBER_LIST_POOL_CAPACITY, except for lists of strings (char*) */
#define STRING_LIST_POOL_CAPACITY 2

/* as NUMBER_LIST_POOL_CAPACITY, except for lists of wildcard ips */
#define WILDCARD_IP_LIST_POOL_CAPACITY 2

/* parsing a probe fills in this struct; then we use it to create an
 * skProbe. */
typedef struct {
    /* probe's name: either sensor name or based on type */
    char               *probe_name;
    /* empty if probe_name is unique, otherwise sensor name */
    char                uniq_prefix[3 + SK_MAX_STRLEN_SENSOR];
    /* SNMP interface map */
    number_list_t      *interfaces[NUM_IFMAPS];
    /* categorize based on IP blocks */
    wildcard_ip_list_t *ipblocks[NUM_IFMAPS];
    /* whether the ipblocks are negative blocks */
    int                 negated[NUM_IFMAPS];
    /* the list of ISP IPs; for 'forrouter' support */
    number_list_t      *isp_ip;
    /* index that should cover all IP-blocks or SNMP-interfaces not
     * covered by other indexes */
    uint32_t            remainder;
    /* priority for probe */
    uint32_t            priority;
    /* host to accept from */
    name_ip_pair_t      accept_from_host;
    /* IP to bind as when being to listen for connections */
    in_addr_t           listen_as_host;
    /* port to bind to when listening for connections */
    uint32_t            listen_on_port;
    /* path to unix domain socket to listen on */
    char               *listen_on_usocket;
    /* path to regular file to read data from */
    char               *read_from_file;
    /* path to directory to poll for newly inserted files */
    char               *poll_directory;
    /* number of errors encountered during parsing */
    int                 error_count;
    /* first *-index seen */
    int                 interface_first_seen;
    /* first *-ipblock seen */
    int                 ipblock_first_seen;
    /* sensor id this probe collects for */
    sensorID_t          sid;
    /* the type of this probe */
    probe_enum_t        probe_type;
    /* the protocol of this probe */
    probe_proto_t       protocol;
    /* log flags for this probe */
    uint32_t            log_flags;
} probe_attr_t;


/* LOCAL FUNCTIONS */

/* wrappers around an sk_vector_t of integers, of skOctetMap_t*, and
 * of char* */
static number_list_t *number_list_new(void);
static void number_list_append_value(number_list_t *nl, uint32_t value);
static string_list_t *string_list_new(void);
static void string_list_append_value(string_list_t *sl, char *value);
static wildcard_ip_list_t *wildcard_ip_list_new(void);
static void wildcard_ip_list_append_value(
    wildcard_ip_list_t *wipl,
    skOctetMap_t       *value);

/* add a new flag to the log flags */
static uint32_t log_flags_add_flag(uint32_t old_val, uint32_t value);

/* create a sensor */
static void sensor_new_sensor(char *s, string_list_t *sl);

/* functions to set attributes of a probe_attr_t */
static void sensor_probe(char *s);
static void probe_name(char *s);
static void probe_priority(uint32_t n);
static void probe_probe_type(probe_enum_t t);
static void probe_protocol(probe_proto_t t);
static void probe_isp_ip(number_list_t *nl);
static void probe_interface(uint32_t idx, number_list_t *nl);
static void probe_ipblock(
    uint32_t            idx,
    wildcard_ip_list_t *wipl,
    int                 negated);
static void probe_listen_as_host(uint32_t a);
static void probe_listen_on_port(uint32_t n);
static void probe_listen_on_usocket(char *s);
static void probe_read_from_file(char *s);
static void probe_poll_directory(char *s);
static void probe_accept_from_host(name_ip_pair_t *a);
static void probe_log_flags(uint32_t n);


/* functions to convert string input to another form */
static uint32_t parse_int_u16(const char *s);
static uint32_t parse_ip_addr(const char *s);
static skOctetMap_t *parse_wildcard_addr(const char *s);
static name_ip_pair_t *parse_resolvable_host(const char *s);
static probe_enum_t parse_probe_type(const char *s);
static probe_proto_t parse_protocol(const char *s);
static char *parse_sensor_name(const char *s);
static uint32_t parse_log_flag(const char *s);


/* LOCAL VARIABLES */

/* the size of the free number_list pool and the number of entries in
 * the pool. */
static number_list_t *number_list_pool[NUMBER_LIST_POOL_CAPACITY];
static int number_list_pool_count = 0;

/* the size of the free string_list pool and the number of entries in
 * the pool. */
static string_list_t *string_list_pool[STRING_LIST_POOL_CAPACITY];
static int string_list_pool_count = 0;

/* the size of the free wildcard_ip_list pool and the number of
 * entries in the pool. */
static wildcard_ip_list_t *wildcard_ip_list_pool[WILDCARD_IP_LIST_POOL_CAPACITY];
static int wildcard_ip_list_pool_count = 0;

/* The parser works on a single global set of probe attributes */
static probe_attr_t g_static_probe;
static probe_attr_t *p = &g_static_probe;



#line 230 "probeconfparse.y"
typedef union {
    char               *string;
    number_list_t      *u32_list;
    string_list_t      *str_list;
    name_ip_pair_t     *addr;
    wildcard_ip_list_t *omap_list;
    skOctetMap_t       *oct_map;
    uint32_t            u32;
    probe_enum_t        p_type;
    probe_proto_t       p_proto;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		111
#define	YYFLAG		-32768
#define	YYNTBASE	24

#define YYTRANSLATE(x) ((unsigned)(x) <= 277 ? yytranslate[x] : 60)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     7,     9,    11,    18,    21,    22,    25,
    27,    29,    31,    33,    35,    37,    39,    41,    43,    45,
    47,    49,    51,    53,    55,    59,    63,    67,    71,    75,
    79,    83,    87,    91,    95,    99,   103,   107,   111,   115,
   119,   123,   125,   128,   132,   134,   136,   139,   143,   145,
   147,   150,   154,   156,   158,   161,   165,   167,   169,   171,
   173,   175,   177,   179,   182,   186
};

static const short yyrhs[] = {    25,
     0,    24,    25,     0,     1,     0,    26,     0,    27,     0,
    20,    56,     6,     4,    47,     6,     0,    30,    28,     0,
     0,    28,    29,     0,    32,     0,    31,     0,    33,     0,
    34,     0,    35,     0,    36,     0,    37,     0,    38,     0,
    39,     0,    40,     0,    41,     0,    42,     0,    43,     0,
    44,     0,     1,     0,    19,    56,     6,     0,    12,    46,
     6,     0,    13,    56,     6,     0,    14,    54,     6,     0,
    15,    55,     6,     0,     7,    51,     6,     0,    22,    45,
     6,     0,    22,    18,     6,     0,    23,    49,     6,     0,
    23,    18,     6,     0,     8,    52,     6,     0,     9,    46,
     6,     0,    10,    57,     6,     0,    16,    57,     6,     0,
    17,    57,     6,     0,     3,    53,     6,     0,    11,    58,
     6,     0,    46,     0,    45,    46,     0,    45,     5,    46,
     0,    21,     0,    48,     0,    47,    48,     0,    47,     5,
    48,     0,    21,     0,    50,     0,    49,    50,     0,    49,
     5,    50,     0,    21,     0,    52,     0,    51,    52,     0,
    51,     5,    52,     0,    21,     0,    21,     0,    21,     0,
    21,     0,    21,     0,    21,     0,    59,     0,    58,    59,
     0,    58,     5,    59,     0,    21,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   287,   288,   289,   297,   298,   305,   316,   319,   320,   323,
   324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
   334,   335,   336,   337,   346,   353,   358,   363,   368,   373,
   378,   382,   387,   391,   396,   401,   406,   411,   416,   421,
   426,   436,   442,   447,   453,   464,   470,   475,   481,   492,
   498,   503,   510,   521,   527,   532,   539,   549,   559,   569,
   579,   589,   599,   603,   608,   614
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ACCEPT_FROM_HOST_T",
"CLASS_T","COMMA","EOL","ISP_IP_T","LISTEN_AS_HOST_T","LISTEN_ON_PORT_T","LISTEN_ON_USOCKET_T",
"LOG_FLAGS_T","PRIORITY_T","PROBE_NAME_T","PROBE_TYPE_T","PROTOCOL_T","READ_FROM_FILE_T",
"POLL_DIRECTORY_T","REMAINDER_T","SENSOR_PROBE_T","SENSOR_T","ID","INTERFACE",
"IPBLOCK","input","input_block","sensor_defn","probe_defn","probe_clauses","probe_clause",
"sensor_probe_clause","priority_clause","probe_name_clause","probe_type_clause",
"probe_protocol_clause","isp_ip_clause","interface_clause","ipblock_clause",
"listen_host_clause","listen_port_clause","listen_usocket_clause","read_file_clause",
"poll_directory_clause","accept_host_clause","log_flags_clause","int_u16_list",
"int_u16","class_list","class","wildcard_ip_list","wildcard_ip","dotted_quad_list",
"dotted_quad","resolvable_host","probe_type","probe_protocol","sensor_name",
"syspath","log_flags_list","log_flag", NULL
};
#endif

static const short yyr1[] = {     0,
    24,    24,    24,    25,    25,    26,    27,    28,    28,    29,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    29,    30,    31,    32,    33,    34,    35,
    36,    36,    37,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    45,    45,    46,    47,    47,    47,    48,    49,
    49,    49,    50,    51,    51,    51,    52,    53,    54,    55,
    56,    57,    58,    58,    58,    59
};

static const short yyr2[] = {     0,
     1,     2,     1,     1,     1,     6,     2,     0,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     1,     2,     3,     1,     1,     2,     3,     1,     1,
     2,     3,     1,     1,     2,     3,     1,     1,     1,     1,
     1,     1,     1,     2,     3,     1
};

static const short yydefact[] = {     0,
     3,     0,     0,     0,     1,     4,     5,     8,    61,     0,
     0,     2,     0,    25,     0,    24,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     9,    11,    10,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,     0,    58,     0,    57,     0,
    54,     0,    45,     0,    62,     0,    66,     0,    63,     0,
     0,    59,     0,    60,     0,     0,     0,     0,     0,    42,
     0,    53,     0,    50,    49,     0,    46,    40,     0,    30,
    55,    35,    36,    37,     0,    41,    64,    26,    27,    28,
    29,    38,    39,    32,     0,    31,    43,    34,     0,    33,
    51,     0,     6,    47,    56,    65,    44,    52,    48,     0,
     0
};

static const short yydefgoto[] = {     4,
     5,     6,     7,    13,    31,     8,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    69,    54,    76,    77,    73,    74,    50,    51,    48,    63,
    65,    10,    56,    58,    59
};

static const short yypact[] = {    14,
-32768,    -7,    -7,     7,-32768,-32768,-32768,-32768,-32768,     6,
    11,-32768,    40,-32768,    24,-32768,    16,    18,    18,    21,
    23,    37,    21,    -7,    47,    48,    23,    23,   -10,    -5,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    49,-32768,    29,-32768,     4,
-32768,    39,-32768,    65,-32768,    67,-32768,    15,-32768,    68,
    69,-32768,    70,-32768,    71,    72,    73,    75,    17,-32768,
    77,-32768,    59,-32768,-32768,    61,-32768,-32768,    18,-32768,
-32768,-32768,-32768,-32768,    37,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    21,-32768,-32768,-32768,    63,-32768,
-32768,    49,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    85,
-32768
};

static const short yypgoto[] = {-32768,
    82,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -23,-32768,   -72,-32768,   -68,-32768,   -18,-32768,-32768,
-32768,     0,    -9,-32768,   -56
};


#define	YYLAST		86


static const short yytable[] = {    60,
    52,    87,    11,   104,   101,    70,   110,    68,    79,    80,
    53,    14,    71,     9,     1,    72,    15,    66,    67,    85,
    86,    95,    96,    61,    49,     2,     3,    46,   106,   109,
   108,    81,     2,     3,    78,    57,    47,    53,    49,    -7,
    16,    53,    17,    55,    82,    97,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    57,    -7,    -7,
   105,    29,    30,    99,   100,   102,   103,    62,    64,    75,
    83,   107,    84,    88,    89,    90,    91,    92,    93,    72,
    94,    75,    98,    72,   111,    12
};

static const short yycheck[] = {    23,
    19,    58,     3,    76,    73,    29,     0,    18,     5,     6,
    21,     6,    18,    21,     1,    21,     6,    27,    28,     5,
     6,     5,     6,    24,    21,    19,    20,     4,    85,   102,
    99,    50,    19,    20,     6,    21,    21,    21,    21,     0,
     1,    21,     3,    21,     6,    69,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    21,    19,    20,
    79,    22,    23,     5,     6,     5,     6,    21,    21,    21,
     6,    95,     6,     6,     6,     6,     6,     6,     6,    21,
     6,    21,     6,    21,     0,     4
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 290 "probeconfparse.y"
{
    skAppPrintErr((PARSE_MSG_ERROR
                   "\tMisplaced or unrecognized keyword"),
                  probescan_filename, probescan_line);
;
    break;}
case 6:
#line 306 "probeconfparse.y"
{
    probe_end();
    sensor_new_sensor(yyvsp[-4].string, yyvsp[-1].str_list);
;
    break;}
case 24:
#line 338 "probeconfparse.y"
{
    skAppPrintErr((PARSE_MSG_ERROR
                   "\tBad keyword or missing value"),
                  probescan_filename, probescan_line);
;
    break;}
case 25:
#line 347 "probeconfparse.y"
{
    probe_end();
    probe_start();
    sensor_probe(yyvsp[-1].string);
;
    break;}
case 26:
#line 354 "probeconfparse.y"
{
    probe_priority(yyvsp[-1].u32);
;
    break;}
case 27:
#line 359 "probeconfparse.y"
{
    probe_name(yyvsp[-1].string);
;
    break;}
case 28:
#line 364 "probeconfparse.y"
{
    probe_probe_type(yyvsp[-1].p_type);
;
    break;}
case 29:
#line 369 "probeconfparse.y"
{
    probe_protocol(yyvsp[-1].p_proto);
;
    break;}
case 30:
#line 374 "probeconfparse.y"
{
    probe_isp_ip(yyvsp[-1].u32_list);
;
    break;}
case 31:
#line 379 "probeconfparse.y"
{
    probe_interface(yyvsp[-2].u32, yyvsp[-1].u32_list);
;
    break;}
case 32:
#line 383 "probeconfparse.y"
{
    probe_interface(yyvsp[-2].u32, NULL);
;
    break;}
case 33:
#line 388 "probeconfparse.y"
{
    probe_ipblock(yyvsp[-2].u32, yyvsp[-1].omap_list, 0);
;
    break;}
case 34:
#line 392 "probeconfparse.y"
{
    probe_ipblock(yyvsp[-2].u32, NULL, 0);
;
    break;}
case 35:
#line 397 "probeconfparse.y"
{
    probe_listen_as_host(yyvsp[-1].u32);
;
    break;}
case 36:
#line 402 "probeconfparse.y"
{
    probe_listen_on_port(yyvsp[-1].u32);
;
    break;}
case 37:
#line 407 "probeconfparse.y"
{
    probe_listen_on_usocket(yyvsp[-1].string);
;
    break;}
case 38:
#line 412 "probeconfparse.y"
{
    probe_read_from_file(yyvsp[-1].string);
;
    break;}
case 39:
#line 417 "probeconfparse.y"
{
    probe_poll_directory(yyvsp[-1].string);
;
    break;}
case 40:
#line 422 "probeconfparse.y"
{
    probe_accept_from_host(yyvsp[-1].addr);
;
    break;}
case 41:
#line 427 "probeconfparse.y"
{
    probe_log_flags(yyvsp[-1].u32);
;
    break;}
case 42:
#line 437 "probeconfparse.y"
{
    number_list_t *nl = number_list_new();
    number_list_append_value(nl, yyvsp[0].u32);
    yyval.u32_list = nl;
;
    break;}
case 43:
#line 443 "probeconfparse.y"
{
    number_list_append_value(yyvsp[-1].u32_list, yyvsp[0].u32);
    yyval.u32_list = yyvsp[-1].u32_list;
;
    break;}
case 44:
#line 448 "probeconfparse.y"
{
    number_list_append_value(yyvsp[-2].u32_list, yyvsp[0].u32);
    yyval.u32_list = yyvsp[-2].u32_list;
;
    break;}
case 45:
#line 454 "probeconfparse.y"
{
    yyval.u32 = parse_int_u16(yyvsp[0].string);
;
    break;}
case 46:
#line 465 "probeconfparse.y"
{
    string_list_t *sl = string_list_new();
    string_list_append_value(sl, yyvsp[0].string);
    yyval.str_list = sl;
;
    break;}
case 47:
#line 471 "probeconfparse.y"
{
    string_list_append_value(yyvsp[-1].str_list, yyvsp[0].string);
    yyval.str_list = yyvsp[-1].str_list;
;
    break;}
case 48:
#line 476 "probeconfparse.y"
{
    string_list_append_value(yyvsp[-2].str_list, yyvsp[0].string);
    yyval.str_list = yyvsp[-2].str_list;
;
    break;}
case 49:
#line 482 "probeconfparse.y"
{
    yyval.string = strdup(yyvsp[0].string);
;
    break;}
case 50:
#line 493 "probeconfparse.y"
{
    wildcard_ip_list_t *wipl = wildcard_ip_list_new();
    wildcard_ip_list_append_value(wipl, yyvsp[0].oct_map);
    yyval.omap_list = wipl;
;
    break;}
case 51:
#line 499 "probeconfparse.y"
{
    wildcard_ip_list_append_value(yyvsp[-1].omap_list, yyvsp[0].oct_map);
    yyval.omap_list = yyvsp[-1].omap_list;
;
    break;}
case 52:
#line 504 "probeconfparse.y"
{
    wildcard_ip_list_append_value(yyvsp[-2].omap_list, yyvsp[0].oct_map);
    yyval.omap_list = yyvsp[-2].omap_list;
;
    break;}
case 53:
#line 511 "probeconfparse.y"
{
    yyval.oct_map = parse_wildcard_addr(yyvsp[0].string);
;
    break;}
case 54:
#line 522 "probeconfparse.y"
{
    number_list_t *nl = number_list_new();
    number_list_append_value(nl, yyvsp[0].u32);
    yyval.u32_list = nl;
;
    break;}
case 55:
#line 528 "probeconfparse.y"
{
    number_list_append_value(yyvsp[-1].u32_list, yyvsp[0].u32);
    yyval.u32_list = yyvsp[-1].u32_list;
;
    break;}
case 56:
#line 533 "probeconfparse.y"
{
    number_list_append_value(yyvsp[-2].u32_list, yyvsp[0].u32);
    yyval.u32_list = yyvsp[-2].u32_list;
;
    break;}
case 57:
#line 540 "probeconfparse.y"
{
    yyval.u32 = parse_ip_addr(yyvsp[0].string);
;
    break;}
case 58:
#line 550 "probeconfparse.y"
{
    yyval.addr = parse_resolvable_host(yyvsp[0].string);
;
    break;}
case 59:
#line 560 "probeconfparse.y"
{
    yyval.p_type = parse_probe_type(yyvsp[0].string);
;
    break;}
case 60:
#line 570 "probeconfparse.y"
{
    yyval.p_proto = parse_protocol(yyvsp[0].string);
;
    break;}
case 61:
#line 580 "probeconfparse.y"
{
    yyval.string = parse_sensor_name(yyval.string);
;
    break;}
case 62:
#line 590 "probeconfparse.y"
{
    yyval.string = strdup(yyvsp[0].string);
;
    break;}
case 63:
#line 600 "probeconfparse.y"
{
    yyval.u32 = yyvsp[0].u32;
;
    break;}
case 64:
#line 604 "probeconfparse.y"
{
    uint32_t n = log_flags_add_flag(yyvsp[-1].u32, yyvsp[0].u32);
    yyval.u32 = n;
;
    break;}
case 65:
#line 609 "probeconfparse.y"
{
    uint32_t n = log_flags_add_flag(yyvsp[-2].u32, yyvsp[0].u32);
    yyval.u32 = n;
;
    break;}
case 66:
#line 615 "probeconfparse.y"
{
    yyval.u32 = parse_log_flag(yyvsp[0].string);
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 620 "probeconfparse.y"


/*
 * *******************   SUPPORTING CODE  ******************************
 */


/*
 *  *****  Number Lists  ***********************************************
 *
 *
 * number_list, a sk_vector_t of uint32_t's
 */


/* get a new number_list from the free-pool; if pool is empty, create
 * a new one */
static number_list_t *number_list_new(void)
{
    number_list_t *nl;

    /* if there are any in the pool, return one.  Otherwise create one. */
    if (number_list_pool_count) {
        --number_list_pool_count;
        nl = number_list_pool[number_list_pool_count];
        skVectorClear(nl);
    } else {
        nl = skVectorNew(sizeof(uint32_t));
    }

    return nl;
}


/* add the number_list to the free-pool.  If the pool is full, just
 * destroy the number_list. */
static void number_list_destroy(number_list_t *nl)
{
    /* If the pool is full, destroy the list we were handed; otherwise
     * add it to the pool. */
    if (number_list_pool_count == NUMBER_LIST_POOL_CAPACITY) {
        skVectorDestroy(nl);
    } else {
        number_list_pool[number_list_pool_count] = nl;
        ++number_list_pool_count;
    }
}


/* remove all number_list's from the pool and destroy them */
static void number_list_pool_empty(void)
{
    int i;

    for (i = 0; i < number_list_pool_count; ++i) {
        skVectorDestroy(number_list_pool[i]);
    }
    number_list_pool_count = 0;
}


/* append the value to the number_list */
static void number_list_append_value(number_list_t *nl, uint32_t value)
{
    skVectorAppendValue(nl, &value);
}


/* get the number of entries in the number_list */
static size_t number_list_entries(number_list_t *nl)
{
    return skVectorGetCount(nl);
}


/* get the value at the specified position */
static uint32_t number_list_get_value(number_list_t *nl, size_t position)
{
    uint32_t val;
    skVectorGetValue(&val, nl, position);
    return val;
}


/*
 *  *****  String Lists  ***********************************************
 *
 *
 * string_list, a sk_vector_t of char*'s, where each char* is a strdup()
 */


/* get a new string_list from the free-pool; if pool is empty, create
 * a new one */
static string_list_t *string_list_new(void)
{
    string_list_t *sl;

    /* if there are any in the pool, return one.  Otherwise create one. */
    if (string_list_pool_count) {
        --string_list_pool_count;
        sl = string_list_pool[string_list_pool_count];
        skVectorClear(sl);
    } else {
        sl = skVectorNew(sizeof(char*));
    }

    return sl;
}


/* add the string_list to the free-pool.  If the pool is full, just
 * destroy the string_list. */
static void string_list_destroy(string_list_t *sl)
{
    size_t i, c;
    char *s;

    /* free the strings in the vector */
    c = skVectorGetCount(sl);
    for (i = 0; i < c; ++i) {
        skVectorGetValue(&s, sl, i);
        if (s != NULL) {
            free(s);
        }
    }

    /* If the pool is full, destroy the list we were handed; otherwise
     * add it to the pool. */
    if (string_list_pool_count == STRING_LIST_POOL_CAPACITY) {
        skVectorDestroy(sl);
    } else {
        string_list_pool[string_list_pool_count] = sl;
        ++string_list_pool_count;
    }
}


/* remove all string_list's from the pool and destroy them */
static void string_list_pool_empty(void)
{
    int i;

    for (i = 0; i < string_list_pool_count; ++i) {
        skVectorDestroy(string_list_pool[i]);
    }
    string_list_pool_count = 0;
}


/* append the value to the string_list */
static void string_list_append_value(string_list_t *sl, char *value)
{
    skVectorAppendValue(sl, &value);
}


/* get the string of entries in the string_list */
static size_t string_list_entries(string_list_t *sl)
{
    return skVectorGetCount(sl);
}


/* get the value at the specified position */
static const char* string_list_get_value(string_list_t *sl, size_t position)
{
    char *val;
    skVectorGetValue(&val, sl, position);
    return val;
}


/*
 *  *****  Wildcard IP Lists  ******************************************
 *
 *
 *  wildcard_ip_list, an sk_vector_t of skOctetMap_t's
 */


/* get a new wildcard_ip_list from the free-pool; if pool is empty,
 * create a new one */
static wildcard_ip_list_t *wildcard_ip_list_new(void)
{
    wildcard_ip_list_t *wipl;

    /* if there are any in the pool, return one.  Otherwise create one. */
    if (wildcard_ip_list_pool_count) {
        --wildcard_ip_list_pool_count;
        wipl = wildcard_ip_list_pool[wildcard_ip_list_pool_count];
        skVectorClear(wipl);
    } else {
        wipl = skVectorNew(sizeof(skOctetMap_t*));
    }

    return wipl;
}


/* add the wildcard_ip_list to the free-pool.  If the pool is full,
 * just destroy the wildcard_ip_list. */
static void wildcard_ip_list_destroy(wildcard_ip_list_t *wipl)
{
    size_t i, c;
    skOctetMap_t *omap;

    /* free the octet-maps in the vector */
    c = skVectorGetCount(wipl);
    for (i = 0; i < c; ++i) {
        skVectorGetValue(&omap, wipl, i);
        if (omap != NULL) {
            free(omap);
        }
    }

    /* If the pool is full, destroy the list we were handed; otherwise
     * add it to the pool. */
    if (wildcard_ip_list_pool_count == WILDCARD_IP_LIST_POOL_CAPACITY) {
        skVectorDestroy(wipl);
    } else {
        wildcard_ip_list_pool[wildcard_ip_list_pool_count] = wipl;
        ++wildcard_ip_list_pool_count;
    }
}


/* remove all wildcard_ip_list's from the pool and destroy them */
static void wildcard_ip_list_pool_empty(void)
{
    int i;

    for (i = 0; i < wildcard_ip_list_pool_count; ++i) {
        skVectorDestroy(wildcard_ip_list_pool[i]);
    }
    wildcard_ip_list_pool_count = 0;
}


/* append the value to the wildcard_ip_list */
static void wildcard_ip_list_append_value(
    wildcard_ip_list_t *wipl,
    skOctetMap_t       *value)
{
    skVectorAppendValue(wipl, &value);
}


/* get the wildcard_ip of entries in the wildcard_ip_list */
static size_t wildcard_ip_list_entries(wildcard_ip_list_t *wipl)
{
    return skVectorGetCount(wipl);
}


/* get the value at the specified position */
static skOctetMap_t *wildcard_ip_list_get_value(
    wildcard_ip_list_t *wipl,
    size_t              position)
{
    skOctetMap_t *omap;
    skVectorGetValue(&omap, wipl, position);
    return omap;
}


/*
 *  *****  Sensors  ****************************************************
 */

/*
 *  sensor_new_sensor(name, class_list);
 *
 *    Create sensor 'name' that belongs to classes 'class_list'.
 */
static void sensor_new_sensor(char *s, string_list_t *sl)
{
    int rv = sksiteCreateTemporarySensor(s, (sk_vector_t*)sl);
    if (rv > 0) {
        /* invalid class */
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tDo not recognize class name '%s'"),
                      probescan_filename, probescan_line,
                      string_list_get_value(sl, rv-1));
    } else if (rv < 0) {
        switch (rv) {
          case -2:
            /* invalid sensor name */
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tSensor name '%s' is not of correct form"),
                          probescan_filename, probescan_line, s);
            break;

          case -3:
            /* duplicate sensor */
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tA sensor named '%s' already exists"),
                          probescan_filename, probescan_line, s);
            break;

          case -4:
            /* too many or too few classes */
            if (string_list_entries(sl) == 0) {
                skAppPrintErr((PARSE_MSG_ERROR
                               "\tNo classes given for test sensor '%s'"),
                              probescan_filename, probescan_line, s);
            } else {
                skAppPrintErr((PARSE_MSG_ERROR
                               "\tToo many classes given "
                               "for test sensor '%s'"),
                              probescan_filename, probescan_line, s);
            }
            break;

          case -1:
            /* bad input */
          default:
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tUnexpected value from sksite: %d"),
                          probescan_filename, probescan_line, rv);
            break;
        }
    }

    if (s) {
        free(s);
        s = NULL;
    }
    if (sl) {
        string_list_destroy(sl);
    }
}


/*
 *  *****  Probes  *****************************************************
 */


/* print the probe attributes -- for debugging */
static void probe_print(void)
{
#if DEBUG
    size_t if_count;
    size_t isp_count;
    size_t i, j;

    DEBUG_PRINTF((("Got a probe (%d errors)\n"
                   "\t probe_name = '%s'\n"
                   "\t sensor_for_probe = '%u'\n"
                   "\t priority = '%u'\n"
                   "\t probe_type = '%u'\n"
                   "\t protocol = '%u'\n"),
                  p->error_count,
                  p->probe_name,
                  p->sid,
                  p->priority,
                  p->probe_type,
                  p->protocol));

    isp_count = ((p->isp_ip != NULL)
                 ? number_list_entries(p->isp_ip)
                 : 0);
    DEBUG_PRINTF(("\t isp_count = '%u'", (unsigned int)isp_count));
    if (isp_count > 0) {
        for (i = 0; i < isp_count; ++i) {
            uint32_t val = number_list_get_value(p->isp_ip, i);
            DEBUG_PRINTF(("%s%u(%s)",
                          ((0 == i) ? " [" : ","), val, num2dot(val)));
        }
        DEBUG_PRINTF(("]"));
    }
    DEBUG_PRINTF(("\n"));

    for (i = 0; i < NUM_IFMAPS; ++i) {
        if_count = ((p->interfaces[i] != NULL)
                    ? number_list_entries(p->interfaces[i])
                    : 0);
        DEBUG_PRINTF(("\t interface_count[%lu] = '%lu'",
                      i, if_count));
        if (if_count > 0) {
            for (j = 0; j < if_count; ++j) {
                DEBUG_PRINTF(("%s%u",
                              ((0 == j) ? " [" : ","),
                              number_list_get_value(p->interfaces[i], j)));
            }
            DEBUG_PRINTF(("]"));
        }
        DEBUG_PRINTF(("\n"));
    }

    DEBUG_PRINTF((("\t listen_as_host = '%u' '%s'\n"
                   "\t listen_on_port = '%u'\n"
                   "\t listen_on_usocket = '%s'\n"
                   "\t read_from_file = '%s'\n"
                   "\t poll_directory = '%s'\n"
                   "\t log_flags = '%u'\n"),
                  p->listen_as_host, num2dot(p->listen_as_host),
                  p->listen_on_port,
                  (p->listen_on_usocket ? p->listen_on_usocket : "NULL"),
                  (p->read_from_file ? p->read_from_file : "NULL"),
                  (p->poll_directory ? p->poll_directory : "NULL"),
                  p->log_flags));

    DEBUG_PRINTF((("\t accept_from_host = '%s' '%u' '%s'\n"),
                  (p->accept_from_host.name
                   ? p->accept_from_host.name
                   : "NULL"),
                  p->accept_from_host.ip,
                  num2dot(p->accept_from_host.ip)));
#endif /* DEBUG */
}


/* Take all the data on the global probe_attr_t and use it to create a
 * new skProbe. */
static void probe_attr_to_sk_probe(void)
{
    probe_def_t *probe = NULL;
    int rv = 0;
    size_t i;

    rv = skProbeCreate(&probe);
    if (rv) { goto END; }

    rv = skProbeSetSensor(probe, p->sid);
    if (rv) { goto END; }

    rv = skProbeSetName(probe, p->probe_name);
    if (rv) { goto END; }

    if (p->priority != UINT16_NO_VALUE) {
        rv = skProbeSetPriority(probe, p->priority);
        if (rv) { goto END; }
    }
    if (p->probe_type != PROBE_ENUM_INVALID) {
        rv = skProbeSetType(probe, p->probe_type);
        if (rv) { goto END; }
    }
    if (p->protocol != PROBE_PROTO_UNSET) {
        rv = skProbeSetProtocol(probe, p->protocol);
        if (rv) { goto END; }
    }
    if (p->isp_ip) {
        rv = skProbeSetIspIps(probe, p->isp_ip);
        if (rv) { goto END; }
    }
    if (p->log_flags != UINT16_NO_VALUE) {
        rv = skProbeSetLogFlags(probe, p->log_flags);
        if (rv) { goto END; }
    }

    for (i = 0; i < NUM_IFMAPS; ++i) {
        if (p->interfaces[i]) {
            rv = skProbeSetInterfaces(probe, p->interfaces[i], i);
            if (rv) { goto END; }
        } else if (p->ipblocks[i]) {
            rv = skProbeSetIpBlock(probe, p->ipblocks[i], p->negated[i], i);
            if (rv) { goto END; }
            /* the probe is now managing the skOctetMap_t's; clear the
             * vector of ipblocks so the maps do not get
             * deallocated. */
            skVectorClear(p->ipblocks[i]);
        }
    }

    if (p->remainder != UINT16_NO_VALUE) {
        if (p->ipblock_first_seen != UINT16_NO_VALUE) {
            rv = skProbeSetIpBlockRemainingIps(probe, p->remainder);
        } else {
            assert(p->interface_first_seen != UINT16_NO_VALUE);
            rv = skProbeSetInterfaceToRemainder(probe, p->remainder);
        }
        if (rv) { goto END; }
    }

    if (p->listen_as_host) {
        rv = skProbeSetListenAsAddr(probe, p->listen_as_host);
        if (rv) { goto END; }
    }
    if (p->listen_on_port != UINT16_NO_VALUE) {
        rv = skProbeSetListenOnPort(probe, p->listen_on_port);
        if (rv) { goto END; }
    }
    if (p->listen_on_usocket) {
        rv = skProbeSetListenOnUnixDomainSocket(probe,
                                                p->listen_on_usocket);
        if (rv) { goto END; }
    }
    if (p->read_from_file) {
        rv = skProbeSetFileSource(probe, p->read_from_file);
        if (rv) { goto END; }
    }
    if (p->poll_directory) {
        rv = 0 /* skProbeSetPollDirectory(probe, p->poll_directory) */;
        if (rv) { goto END; }
    }
    if (p->accept_from_host.name) {
        rv = skProbeSetAcceptFromHost(probe, p->accept_from_host.name,
                                      p->accept_from_host.ip);
        if (rv) { goto END; }
    }

    rv = probeConfProbeVerify(probe);

  END:
    if ((rv != 0) && (NULL != probe)) {
        ++g_probe_err;
        skProbeDestroy(&probe);
    }
}


/* This should be called just before starting a new probe and when we
 * finish reading a file (to complete the last probe).  It will try to
 * convert the data from config file---which is stored in the global
 * probe_attr_t---to an skProbe, and then it will free() all memory
 * the parser has allocated for this probe_attr_t */
void probe_end(void)
{
    int i;

    if (p->probe_name != NULL) {
        probe_print();

        if (p->error_count == 0) {
            probe_attr_to_sk_probe();
        }
    }

    /* Free everything we allocated */
    if (p->probe_name) {
        free(p->probe_name);
    }
    if (p->isp_ip) {
        number_list_destroy(p->isp_ip);
    }
    for (i = 0; i < NUM_IFMAPS; ++i) {
        if (p->interfaces[i]) {
            number_list_destroy(p->interfaces[i]);
        }
    }
    if (p->listen_on_usocket) {
        free(p->listen_on_usocket);
    }
    if (p->accept_from_host.name) {
        free(p->accept_from_host.name);
    }

    memset(p, 0, sizeof(probe_attr_t));
}


/* Begin a new probe by setting the memory of the global probe_attr_t
 * into its initial state. */
void probe_start(void)
{
    memset(p, 0, sizeof(probe_attr_t));
    p->priority             = UINT16_NO_VALUE;
    p->probe_type           = PROBE_ENUM_INVALID;
    p->protocol             = PROBE_PROTO_UNSET;
    p->listen_on_port       = UINT16_NO_VALUE;
    p->sid                  = SK_INVALID_SENSOR;
    p->remainder            = UINT16_NO_VALUE;
    p->interface_first_seen = UINT16_NO_VALUE;
    p->ipblock_first_seen   = UINT16_NO_VALUE;
    p->log_flags            = UINT16_NO_VALUE;
}


/*
 *  sensor_probe(sensor_name);
 *
 *    Start a new probe that belongs to the sensor 'sensor_name'.  Set
 *    the probe's name to 'sensor_name' as well.
 */
static void sensor_probe(char *s)
{
    /* see if this is a defined sensor */
    p->sid = sksiteSensorLookup(s);
    if (p->sid == SK_INVALID_SENSOR) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tName '%s' is not the name of a sensor"),
                      probescan_filename, probescan_line, s);
        ++p->error_count;
    }

    /* Set the probe's name to 's' */
    p->probe_name = s;
}


/*
 *  probe_name(probe_name);
 *
 *    Set the name of the global probe to 'probe_name'.
 */
static void probe_name(char *s)
{
    size_t len;

    /* name is legal? */
    if (0 != sksiteSensorNameIsLegal(s)) {
        /* message already printed */
        ++p->error_count;
    }
    if (p->probe_name) {
        free(p->probe_name);
    }

    /* store info */
    p->probe_name = s;

    /* set the unique prefix used when printing error messages, but
     * don't set it if the probe-name is the same as the probe's
     * sensor */
    if (p->sid != SK_INVALID_SENSOR && sksiteSensorLookup(s) != p->sid) {
        /* probe's name is different than sensor's name */
        if ( sksiteSensorExists(p->sid) ) {
            sksiteSensorGetName(p->uniq_prefix, sizeof(p->uniq_prefix),
                                p->sid);
            len = strlen(p->uniq_prefix);
            assert(len <= SK_MAX_STRLEN_SENSOR);
            p->uniq_prefix[len] = '/';
            p->uniq_prefix[len+1] = '\0';
        }
    }
}


/*
 *  probe_priority(n);
 *
 *    Set the priority of the global probe to n.
 */
static void probe_priority(uint32_t n)
{
    /* see if parser got valid value(s) */
    if (n == UINT16_NO_VALUE) {
        /* error msg printed by parser */
        ++p->error_count;
        return;
    }

    /* check for value out of range */
    if (n > PROBE_MAX_PRIORITY) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tPriority %u too large; use 0 <= n <= %d"),
                      probescan_filename, probescan_line,
                      n, PROBE_MAX_PRIORITY);
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->priority != UINT16_NO_VALUE) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info */
    p->priority = n;
}


/*
 *  probe_probe_type(t);
 *
 *    Set the probe-type of the global probe to 't'.
 */
static void probe_probe_type(probe_enum_t t)
{
    /* see if parser got valid value(s) */
    if (t == PROBE_ENUM_INVALID) {
        /* error msg printed by parser */
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->probe_type != PROBE_ENUM_INVALID) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info */
    p->probe_type = t;
}


/*
 *  probe_protocol(t);
 *
 *    Set the probe-type of the global probe to 't'.
 */
static void probe_protocol(probe_proto_t t)
{
    /* see if parser got valid value(s) */
    if (t == PROBE_PROTO_UNSET) {
        /* error msg printed by parser */
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->protocol != PROBE_PROTO_UNSET) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info */
    p->protocol = t;
}


/*
 *  probe_isp_ip(list);
 *
 *    Set the isp-ip's on the global probe to 'list'.
 */
static void probe_isp_ip(number_list_t *nl)
{
    size_t i;
    size_t count = number_list_entries(nl);
    uint32_t val;

    /* see if parser got valid value(s) */
    for (i = 0; i < count; ++i) {
        val = number_list_get_value(nl, i);
        if (val == 0) {
            ++p->error_count;
            return;
        }
    }

    /* warn on overwrite */
    if (p->isp_ip != NULL) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
        number_list_destroy(p->isp_ip);
    }

    /* store info */
    p->isp_ip = nl;
}


/*
 *  probe_interface(idx, list);
 *
 *    Set the ifmap-interface list indexed by 'idx' on the global
 *    probe to 'list'.
 *
 *    If 'list' is NULL, set the ifmap-interface list to all the
 *    indexes NOT listed on other interfaces---set it to the
 *    'remainder' of the interfaces.
 */
static void probe_interface(uint32_t idx, number_list_t *nl)
{
    size_t i;
    size_t count;
    uint32_t val;

    assert(idx < NUM_IFMAPS);

    if (nl) {
        count = number_list_entries(nl);
        /* see if parser got valid value(s) */
        for (i = 0; i < count; ++i) {
            val = number_list_get_value(nl, i);
            if (val == UINT16_NO_VALUE) {
                ++p->error_count;
                return;
            }
        }
    }

    /* cannot set interface when ip-block already set */
    if (p->ipblock_first_seen != UINT16_NO_VALUE) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tCannot set %s for probe %s%s because\n"
                       "\t%s-index was previously set"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name,
                      ifmap_group_id_name[p->ipblock_first_seen]);
        ++p->error_count;
        return;
    }

    /* only one interface may contain the remainding SNMP values */
    if ((nl == NULL) && (p->remainder != UINT16_NO_VALUE)) {
        if (p->remainder == idx) {
            /* repeated: "foo-index remainder".  ignore */
            return;
        }
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tCannot set %s for probe %s%s because\n"
                       "\tthe %s interface has already claimed the"
                       "remaining SNMP values"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name,
                      ifmap_group_id_name[p->remainder]);
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->interfaces[idx] != NULL) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
        number_list_destroy(p->interfaces[idx]);
        p->interfaces[idx] = NULL;
    } else if (p->remainder == idx) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
        p->remainder = UINT16_NO_VALUE;
    }

    /* store info */
    if (nl) {
        p->interfaces[idx] = nl;
    } else {
        p->remainder = idx;
    }
    if (p->interface_first_seen == UINT16_NO_VALUE) {
        p->interface_first_seen = idx;
    }
}


/*
 *  probe_ipblock(idx, ip_list, negated);
 *
 *    When 'ip_list' is NULL, set a flag for this 'idx' noting that
 *    its interface-ipblock list should be set to any IP addresses not
 *    covered by other IP blocks.
 *
 *    When 'negated' is 0, set the interface-ipblocks for the
 *    'idx' interface of the global probe to 'ip_list'.
 *
 *    When negated is non-zero, set the interface-ipblocks for the
 *    'idx' interface of the global probe to the inverse of 'ip_list'.
 */
static void probe_ipblock(
    uint32_t            idx,
    wildcard_ip_list_t *wipl,
    int                 negated)
{
    size_t i;
    size_t count;
    skOctetMap_t *val;

    assert(idx < NUM_IFMAPS);

    if (wipl) {
        count = wildcard_ip_list_entries(wipl);
        /* see if parser got valid value(s) */
        for (i = 0; i < count; ++i) {
            val = wildcard_ip_list_get_value(wipl, i);
            if (val == NULL) {
                ++p->error_count;
                return;
            }
        }
    }

    /* cannot set ip-block when interface already set */
    if (p->interface_first_seen != UINT16_NO_VALUE) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tCannot set %s for probe %s%s because\n"
                       "\t%s-index was previously set"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name,
                      ifmap_group_id_name[p->interface_first_seen]);
        ++p->error_count;
        return;
    }

    /* only one interface may contain the remainding IPs */
    if ((wipl == NULL) && (p->remainder != UINT16_NO_VALUE)) {
        if (p->remainder == idx) {
            /* repeated: "foo-ipblock remainder".  ignore */
            return;
        }
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tCannot set %s for probe %s%s because\n"
                       "\tthe %s interface has already claimed the"
                       "remaining IP space"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name,
                      ifmap_group_id_name[p->remainder]);
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->ipblocks[idx] != NULL) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
        wildcard_ip_list_destroy(p->ipblocks[idx]);
        p->ipblocks[idx] = NULL;
    } else if (p->remainder == idx) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
        p->remainder = UINT16_NO_VALUE;
    }

    /* store info */
    if (wipl) {
        p->negated[idx] = negated;
        p->ipblocks[idx] = wipl;
    } else {
        p->remainder = idx;
    }
    if (p->ipblock_first_seen == UINT16_NO_VALUE) {
        p->ipblock_first_seen = idx;
    }
}


/*
 *  probe_listen_as_host(n);
 *
 *    Set the global probe to listen for flows as the host IP 'n'.
 */
static void probe_listen_as_host(uint32_t n)
{
    /* see if parser got valid value(s) */
    if (n == 0) {
        /* error msg printed by parser */
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->listen_as_host != 0) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info */
    p->listen_as_host = n;
}


/*
 *  probe_listen_on_port(n);
 *
 *    Set the global probe to listen for flows on port 'n'.
 */
static void probe_listen_on_port(uint32_t n)
{
    /* see if parser got valid value(s) */
    if (n == UINT16_NO_VALUE) {
        /* error msg printed by parser */
        ++p->error_count;
        return;
    }

    /* warn on overwrite */
    if (p->listen_on_port != UINT16_NO_VALUE) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info */
    p->listen_on_port = n;
}


/*
 *  probe_listen_on_usocket(s);
 *
 *    Set the global probe to listen for flows on the unix domain socket 's'.
 */
static void probe_listen_on_usocket(char *s)
{
    /* warn on overwrite */
    if (p->listen_on_usocket != NULL) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info; we already made a copy of 's' */
    p->listen_on_usocket = s;
}


/*
 *  probe_read_from_file(s);
 *
 *    Set the global probe to read flows from the file 's'.
 */
static void probe_read_from_file(char *s)
{
    /* warn on overwrite */
    if (p->read_from_file != NULL) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info; we already made a copy of 's' */
    p->read_from_file = s;
}


/*
 *  probe_poll_directory(s);
 *
 *    Set the global probe to read flows from files that appear in the
 *    directory 's'.
 */
static void probe_poll_directory(char *s)
{
    /* warn on overwrite */
    if (p->poll_directory != NULL) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    /* store info; we already made a copy of 's' */
    p->poll_directory = s;
}


/*
 *  probe_accept_from_host(a);
 *
 *    Set the global probe to accept data from the host a.
 */
static void probe_accept_from_host(name_ip_pair_t *a)
{
    /* see if parser got valid value(s) */
    if (a->ip == 0) {
        /* error msg printed by parser */
        ++p->error_count;
        if (a->name) {
            free(a->name);
        }
    } else {
        /* warn on overwrite */
        if (p->accept_from_host.name != NULL) {
            skAppPrintErr((PARSE_MSG_WARN
                           "\tOverwriting previous %s value for probe %s%s"),
                          probescan_filename, probescan_line,
                          probescan_clause, p->uniq_prefix, p->probe_name);
            free(p->accept_from_host.name);
        }

        /* store info */
        p->accept_from_host.ip   = a->ip;
        p->accept_from_host.name = a->name;
    }

    a->name = NULL;
}


/*
 *  probe_log_flags(n);
 *
 *    Set the log flags on the probe to 'n';
 */
static void probe_log_flags(uint32_t n)
{
    /* warn on overwrite */
    if (p->log_flags != UINT16_NO_VALUE) {
        skAppPrintErr((PARSE_MSG_WARN
                       "\tOverwriting previous %s value for probe %s%s"),
                      probescan_filename, probescan_line,
                      probescan_clause, p->uniq_prefix, p->probe_name);
    }

    if (n == UINT16_NO_VALUE) {
        /* some error in parsing log flags */
        ++p->error_count;
    }

    /* store value */
    p->log_flags = n;
}


/*
 *  val = parse_int_u16(s);
 *
 *    Parse 's' as a integer from 0 to 0xFFFF inclusive.
 */
static uint32_t parse_int_u16(const char *s)
{
    uint32_t num;
    int rv;

    rv = skStringParseUint32(&num, s, 0, 0xFFFF);
    if (rv == 0) {
        /* everything is good. */
    } else if (rv == -12) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tValue (%s) for %s is too large; use 0 <= n < 65536"),
                      probescan_filename, probescan_line,
                      s, probescan_clause);
        num = UINT16_NO_VALUE;
    } else {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tUnable to parse %s value '%s'"),
                      probescan_filename, probescan_line,
                      probescan_clause, s);
        num = UINT16_NO_VALUE;
    }

    return num;
}


/*
 *  octet_map = parse_wildcard_addr(ip);
 *
 *    Parse 'ip' as an IP address block in SiLK wildcard notation.
 *    Because the scanner does not allow comma as part of an ID, we
 *    will never see things like  "10.20.30.40,50".
 *
 *    Return the set of ips as an skOctetMap_t*, or NULL on error.
 */
static skOctetMap_t *parse_wildcard_addr(const char *s)
{
    skOctetMap_t *omap;

    omap = malloc(sizeof(skOctetMap_t));
    if (!omap) {
        return NULL;
    }

    if (skStringParseWildcardIP(omap, s)) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tCannot parse IP address block '%s'"),
                      probescan_filename, probescan_line,
                      s);
        free(omap);
        return NULL;
    }

    return omap;
}


/*
 *  ip = parse_ip_addr(ip);
 *
 *    Parse 'ip' as an IP address.  Return the IP.
 */
static uint32_t parse_ip_addr(const char *s)
{
    uint32_t num;

    if (skStringParseIP(&num, s)) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tCannot parse IP addresses '%s'"),
                      probescan_filename, probescan_line,
                      s);
        num = 0;
    }

    return num;
}


/*
 *  name_ip = parse_resolvable_host(name);
 *
 *    Parse 'name' as a resolvable host, i.e., pass 'name' to
 *    gethostbyname().  Returns a pointer to a static struct that
 *    contains the name and the IP address.
 */
static name_ip_pair_t *parse_resolvable_host(const char *s)
{
    static name_ip_pair_t a = {(in_addr_t)0, NULL};
    struct hostent *he;
    in_addr_t addr;

    if (a.name) {
        free(a.name);
    }
    memset(&a, 0, sizeof(name_ip_pair_t));
    a.name = strdup(s);

    he = gethostbyname(s);
    if (he == NULL || he->h_length != sizeof(in_addr_t)) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tUnable to resolve %s value '%s'"),
                      probescan_filename, probescan_line,
                      probescan_clause, s);
    } else {
        memcpy(&addr, he->h_addr, sizeof(in_addr_t));
        a.ip = ntohl(addr);
    }

    return &a;
}


/*
 *  type = parse_probe_type(s);
 *
 *    Parse 's' as the type of a probe.  Return the type.
 */
static probe_enum_t parse_probe_type(const char *s)
{
    probe_enum_t type;

    type = skProbetypeNameToEnum(s);
    if (type == PROBE_ENUM_INVALID) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tDo not recognize probe type '%s'"),
                      probescan_filename, probescan_line, s);
    }

    return type;
}


/*
 *  proto = parse_protocol(s);
 *
 *    Parse 's' as a protocol.  Return the protocol.
 */
static probe_proto_t parse_protocol(const char *s)
{
    probe_proto_t proto = PROBE_PROTO_UNSET;
    uint32_t num;

    if (isdigit((int)*s)) {
        /* parse as a number */
        if (skStringParseUint32(&num, s, 0, 255)) {
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tInvalid protocol value '%s'"),
                          probescan_filename, probescan_line, s);
        } else {
            switch (num) {
              case 6:
                proto = PROBE_PROTO_TCP;
                break;
              case 17:
                proto = PROBE_PROTO_UDP;
                break;
              case 132:
                proto = PROBE_PROTO_SCTP;
                break;
              default:
                skAppPrintErr((PARSE_MSG_ERROR
                               "\tInvalid protocol value '%u'"),
                              probescan_filename, probescan_line, num);
                break;
            }
        }
    } else {
        proto = skProbeNameToProtocol(s);
        if (proto == PROBE_PROTO_UNSET) {
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tDo not recognize protocol '%s'"),
                          probescan_filename, probescan_line, s);
        }
    }

    return proto;
}


/*
 *  sensor_name = parse_sensor_name(s);
 *
 *    Complain if 's' is an illegal sensor name.  Return a copy of s.
 */
static char *parse_sensor_name(const char *s)
{
    int rv;

    rv = sksiteSensorNameIsLegal(s);
    if (rv != 0) {
        if (rv > 0) {
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tSensor name '%s'"
                           " contains the illegal character '%c'"),
                          probescan_filename, probescan_line, s, s[rv-1]);
        } else if (rv == -1) {
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tSensor name '%s'"
                           " is too short."),
                          probescan_filename, probescan_line, s);
        } else if (rv == -2) {
            skAppPrintErr((PARSE_MSG_ERROR
                           "\tSensor name '%s' "
                           " is too long; only %d characters permitted."),
                          probescan_filename, probescan_line,
                          s, SK_MAX_STRLEN_SENSOR);
        }
    }

    return strdup(s);
}


/*
 *  new_flags = log_flags_add_flag(old_flags, flag);
 *
 *    Add 'flag' to the 'old_flags' and return the new flags.  Warn if
 *    either value is explicitly "NONE".
 */
static uint32_t log_flags_add_flag(uint32_t old_flags, uint32_t flag)
{
    if ((old_flags == SOURCE_LOG_NONE) || (flag == SOURCE_LOG_NONE)) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tThe %s 'none' ignored when"
                       " mixed with other values on probe %s%s"),
                      probescan_filename, probescan_line, probescan_clause,
                      p->uniq_prefix, p->probe_name);
    }

    return (old_flags | flag);
}


/*
 *  flag = parse_log_flag(s);
 *
 *    Parse the string 's' as a log flag.
 */
static uint32_t parse_log_flag(const char *s)
{
    if (!s || !*s) {
        skAppPrintErr((PARSE_MSG_ERROR
                       "\tMissing value for %s on probe %s%s"),
                      probescan_filename, probescan_line, probescan_clause,
                      p->uniq_prefix, p->probe_name);
        return UINT16_NO_VALUE;
    }

    switch (*s) {
      case 'a':
        if (0 == strcmp(s, "all")) {
            return SOURCE_LOG_ALL;
        }
        break;

      case 'b':
        if (0 == strcmp(s, "bad")) {
            return SOURCE_LOG_BAD;
        }
        break;

      case 'm':
        if (0 == strcmp(s, "missing")) {
            return SOURCE_LOG_MISSING;
        }
        break;

      case 'n':
        if (0 == strcmp(s, "none")) {
            return SOURCE_LOG_NONE;
        }
        break;
    }

    skAppPrintErr((PARSE_MSG_ERROR
                   "\tDo not recognize %s value '%s' on probe %s%s"),
                  probescan_filename, probescan_line, probescan_clause,
                  s, p->uniq_prefix, p->probe_name);
    return UINT16_NO_VALUE;
}


int yyerror(char UNUSED(*s))
{
    return 0;
}


void probeConfParseTeardown(void)
{
    number_list_pool_empty();
    string_list_pool_empty();
    wildcard_ip_list_pool_empty();
}


/*
** Local variables:
** mode:c
** indent-tabs-mode:nil
** c-basic-offset:4
** End:
*/
