
/*  A Bison parser, made from /Users/mthomas/.tmp/silktools-0.11.2/src/libsilk/sksiteconfig_parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TOK_NL	257
#define	TOK_ATOM	258
#define	TOK_INTEGER	259
#define	TOK_STRING	260
#define	TOK_CLASS	261
#define	TOK_DEF_CLASS	262
#define	TOK_DEF_TYPES	263
#define	TOK_END_CLASS	264
#define	TOK_END_GROUP	265
#define	TOK_GROUP	266
#define	TOK_INCLUDE	267
#define	TOK_PATH_FORMAT	268
#define	TOK_SENSOR	269
#define	TOK_SENSORS	270
#define	TOK_TYPE	271
#define	TOK_VERSION	272
#define	ERR_UNK_CMD	273
#define	ERR_UNREC	274
#define	ERR_UNTERM_STRING	275
#define	ERR_STR_TOO_LONG	276
#define	ERR_INVALID_OCTAL_ESCAPE	277

#line 1 "sksiteconfig_parse.y"

/*
** Copyright (C) 2006-2007 by Carnegie Mellon University.
**
** @OPENSOURCE_HEADER_START@
** 
** Use of the SILK system and related source code is subject to the terms 
** of the following licenses:
** 
** GNU Public License (GPL) Rights pursuant to Version 2, June 1991
** Government Purpose License Rights (GPLR) pursuant to DFARS 252.225-7013
** 
** NO WARRANTY
** 
** ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER 
** PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON UNIVERSITY 
** PURSUANT TO THIS LICENSE (HEREINAFTER THE "DELIVERABLES") ARE ON AN 
** "AS-IS" BASIS. CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY 
** KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT 
** LIMITED TO, WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABILITY, INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE 
** OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT, 
** SPECIAL OR CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY 
** TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE, REGARDLESS OF 
** WHETHER SUCH PARTY WAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES. 
** LICENSEE AGREES THAT IT WILL NOT MAKE ANY WARRANTY ON BEHALF OF 
** CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON 
** CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED WITH THE 
** DELIVERABLES UNDER THIS LICENSE.
** 
** Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie 
** Mellon University, its trustees, officers, employees, and agents from 
** all claims or demands made against them (and any related losses, 
** expenses, or attorney's fees) arising out of, or relating to Licensee's 
** and/or its sub licensees' negligent use or willful misuse of or 
** negligent conduct or willful misconduct regarding the Software, 
** facilities, or other rights or assistance granted by Carnegie Mellon 
** University under this License, including, but not limited to, any 
** claims of product liability, personal injury, death, damage to 
** property, or violation of any laws or regulations.
** 
** Carnegie Mellon University Software Engineering Institute authored 
** documents are sponsored by the U.S. Department of Defense under 
** Contract F19628-00-C-0003. Carnegie Mellon University retains 
** copyrights in all material produced under this contract. The U.S. 
** Government retains a non-exclusive, royalty-free license to publish or 
** reproduce these documents, or allow others to do so, for U.S. 
** Government purposes only pursuant to the copyright license under the 
** contract clause at 252.227.7013.
** 
** @OPENSOURCE_HEADER_END@
*/

/*
**  Parser for silk toolset configuration file
**
*/

#include "silk.h"

RCSIDENT("$SiLK: sksiteconfig_parse.y 6308 2007-02-15 16:24:48Z mthomas $");

#include "sksiteconfig.h"
#include "silk_site.h"
#include "sksite.h"


/* LOCAL FUNCTIONS */

/* Handle config file version */
static void do_version(char *str);

/* Define sensor */
static void do_sensor(int id, char *name);

/* Define path-format */
static void do_path_format(char *fmt);

/* Include a file */
static void do_include(char *filename);

/* Begin defining a group */
static void do_group(char *groupname);

/* Add sensors to a group definition */
static void do_group_sensors(sk_vector_t *sensors);

/* Finish defining a group */
static void do_end_group(void);

/* Begin defining a class */
static void do_class(char *classname);

/* Add sensors to a class definition */
static void do_class_sensors(sk_vector_t *sensors);

/* Define type within a class definition */
static void do_class_type(int id, char *name, char *prefix);

/* Define the default types for a class */
static void do_class_default_types(sk_vector_t *types);

/* Finish defining a class */
static void do_end_class(void);

/* Set the default class */
static void do_default_class(char *classname);

/* Report an error while parsing (printf style) */
#define do_err sksiteconfigErr

/* Report a context error, like trying to define a sensor in a class */
static void do_err_ctx(const char *ctx, const char *cmd);

/* Report an argument error: too many, too few, or the wrong args */
static void do_err_args(const char *cmd);

/* Report an argument error: shouldn't be any arguments */
static void do_err_args_none(const char *cmd);


/* EXPORTED VARIABLES */

/* set to 1 to use the test handlers, which output what they think they're
 * seeing, for testing purposes. */
int sksiteconfig_testing = 0;


/* LOCAL VARIABLES */

/* current group or class being filled in--only one should be non-NULL
 * at a time. */
static char *current_group = NULL;
static sensorgroupID_t current_group_id = SK_INVALID_SENSORGROUP;
static char *current_class = NULL;
static classID_t current_class_id = SK_INVALID_CLASS;


#line 140 "sksiteconfig_parse.y"
typedef union {
    int integer;
    char *str;
    sk_vector_t *str_list;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		180
#define	YYFLAG		-32768
#define	YYNTBASE	24

#define YYTRANSLATE(x) ((unsigned)(x) <= 277 ? yytranslate[x] : 51)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,    11,    15,    16,    19,    22,    26,
    30,    31,    34,    37,    39,    41,    43,    45,    47,    49,
    51,    53,    55,    57,    59,    61,    63,    65,    69,    73,
    77,    81,    85,    89,    93,    97,   101,   105,   109,   113,
   117,   121,   125,   129,   133,   137,   141,   145,   149,   153,
   157,   161,   165,   169,   173,   177,   181,   185,   189,   193,
   197,   201,   206,   210,   214,   218,   222,   226,   229,   233,
   237,   241,   245,   249,   254,   260,   264,   267,   271,   273,
   275,   277,   279,   280
};

static const short yyrhs[] = {    -1,
    24,     3,     0,    24,    29,     0,    35,    26,    47,     0,
     7,     1,     3,     0,     0,    26,     3,     0,    26,    30,
     0,    37,    28,    43,     0,    12,     1,     3,     0,     0,
    28,     3,     0,    28,    31,     0,    25,     0,    36,     0,
    27,     0,    38,     0,    39,     0,    40,     0,    41,     0,
    32,     0,    44,     0,    45,     0,    46,     0,    34,     0,
    42,     0,    33,     0,    10,     1,     3,     0,    11,     1,
     3,     0,    16,     1,     3,     0,    17,     1,     3,     0,
    19,     1,     3,     0,    20,     1,     3,     0,     7,     1,
     3,     0,     8,     1,     3,     0,    10,     1,     3,     0,
    12,     1,     3,     0,    13,     1,     3,     0,    14,     1,
     3,     0,    15,     1,     3,     0,    17,     1,     3,     0,
    18,     1,     3,     0,    19,     1,     3,     0,    20,     1,
     3,     0,     7,     1,     3,     0,     8,     1,     3,     0,
    11,     1,     3,     0,    12,     1,     3,     0,    13,     1,
     3,     0,    14,     1,     3,     0,    15,     1,     3,     0,
    18,     1,     3,     0,    19,     1,     3,     0,    20,     1,
     3,     0,     7,    49,     3,     0,     8,    49,     3,     0,
    12,    49,     3,     0,    13,    49,     3,     0,    13,     1,
     3,     0,    14,    49,     3,     0,    14,     1,     3,     0,
    15,    48,    49,     3,     0,    15,     1,     3,     0,    18,
    49,     3,     0,    18,     1,     3,     0,    16,    50,     3,
     0,    16,     1,     3,     0,    11,     3,     0,    11,     1,
     3,     0,     9,    50,     3,     0,     9,     1,     3,     0,
    16,    50,     3,     0,    16,     1,     3,     0,    17,    48,
    49,     3,     0,    17,    48,    49,    49,     3,     0,    17,
     1,     3,     0,    10,     3,     0,    10,     1,     3,     0,
     5,     0,     4,     0,     6,     0,     5,     0,     0,    50,
    49,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   168,   170,   171,   174,   176,   179,   181,   182,   185,   187,
   190,   192,   193,   198,   200,   201,   202,   203,   204,   205,
   206,   209,   211,   212,   213,   216,   218,   223,   225,   226,
   227,   228,   230,   233,   235,   236,   237,   238,   239,   240,
   241,   242,   243,   245,   248,   250,   251,   252,   253,   254,
   255,   256,   257,   258,   261,   267,   271,   277,   279,   282,
   284,   287,   289,   292,   294,   297,   299,   302,   304,   307,
   309,   312,   314,   317,   319,   320,   323,   325,   329,   335,
   337,   338,   341,   343
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TOK_NL",
"TOK_ATOM","TOK_INTEGER","TOK_STRING","TOK_CLASS","TOK_DEF_CLASS","TOK_DEF_TYPES",
"TOK_END_CLASS","TOK_END_GROUP","TOK_GROUP","TOK_INCLUDE","TOK_PATH_FORMAT",
"TOK_SENSOR","TOK_SENSORS","TOK_TYPE","TOK_VERSION","ERR_UNK_CMD","ERR_UNREC",
"ERR_UNTERM_STRING","ERR_STR_TOO_LONG","ERR_INVALID_OCTAL_ESCAPE","top_cmd_list",
"block_class","class_cmd_list","block_group","group_cmd_list","top_cmd","class_cmd",
"group_cmd","err_top","err_grp","err_cls","cmd_class","cmd_default_class","cmd_group",
"cmd_include","cmd_path_format","cmd_sensor","cmd_version","cmd_group_sensors",
"cmd_end_group","cmd_class_default_types","cmd_class_sensors","cmd_class_type",
"cmd_end_class","int","str","str_list", NULL
};
#endif

static const short yyr1[] = {     0,
    24,    24,    24,    25,    25,    26,    26,    26,    27,    27,
    28,    28,    28,    29,    29,    29,    29,    29,    29,    29,
    29,    30,    30,    30,    30,    31,    31,    32,    32,    32,
    32,    32,    32,    33,    33,    33,    33,    33,    33,    33,
    33,    33,    33,    33,    34,    34,    34,    34,    34,    34,
    34,    34,    34,    34,    35,    36,    37,    38,    38,    39,
    39,    40,    40,    41,    41,    42,    42,    43,    43,    44,
    44,    45,    45,    46,    46,    46,    47,    47,    48,    49,
    49,    49,    50,    50
};

static const short yyr2[] = {     0,
     0,     2,     2,     3,     3,     0,     2,     2,     3,     3,
     0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     4,     3,     3,     3,     3,     3,     2,     3,     3,
     3,     3,     3,     4,     5,     3,     2,     3,     1,     1,
     1,     1,     0,     2
};

static const short yydefact[] = {     1,
     0,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    14,    16,     3,    21,     6,
    15,    11,    17,    18,    19,    20,     0,    80,    82,    81,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     5,    55,    56,    28,    29,    10,    57,    59,    58,
    61,    60,    63,     0,    30,    31,    65,    64,    32,    33,
     7,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     8,    25,    22,    23,    24,
     4,    12,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    13,    27,    26,     9,    62,
     0,     0,     0,     0,     0,    77,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    68,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    45,    46,    71,    70,    84,    78,    47,
    48,    49,    50,    51,    73,    72,    76,     0,    52,    53,
    54,    34,    35,    36,    69,    37,    38,    39,    40,    67,
    66,    41,    42,    43,    44,    74,     0,    75,     0,     0
};

static const short yydefgoto[] = {     1,
    16,    50,    17,    51,    18,    86,   106,    19,   107,    87,
    20,    21,    22,    23,    24,    25,    26,   108,   109,    88,
    89,    90,    91,    43,   148,   114
};

static const short yypact[] = {-32768,
     8,-32768,    84,   115,     1,    30,    90,    96,   102,     2,
    38,    55,   108,    56,    57,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    58,-32768,-32768,-32768,
    71,    77,    83,    89,    95,   101,   107,   132,   133,   134,
   135,-32768,   115,   136,   137,   138,   139,   140,   141,    34,
    52,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   142,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    86,    92,    29,    11,    98,   104,   110,   145,   146,
    72,    12,   147,   148,   149,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   150,   151,   152,    35,   153,   155,   156,   157,
    78,   158,   159,   160,   161,-32768,-32768,-32768,-32768,-32768,
   162,   163,   164,   112,   165,-32768,   166,   167,   168,   169,
   170,   171,   120,   172,   115,   173,   174,   175,   176,   177,
   178,   179,-32768,   180,   181,   182,   183,   184,   124,   185,
   186,   187,   188,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   128,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   189,-32768,   193,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    81,    -3,   -72
};


#define	YYLAST		193


static const short yytable[] = {    31,
    32,    33,    41,    36,    38,    40,    42,   179,   123,    47,
     2,   115,   124,   116,     3,     4,    42,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,   139,   113,
    34,   -83,   -83,   -83,   -83,   132,    71,   133,    44,    64,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    92,    45,    48,    49,    93,    94,
    52,    95,    96,    97,    98,    99,   100,   101,   102,   103,
   104,   105,   122,    53,   -83,   -83,   -83,   -83,   138,    54,
   -83,   -83,   -83,   -83,    27,    55,   111,    28,    29,    30,
    35,    56,   112,    28,    29,    30,    37,    57,   117,    28,
    29,    30,    39,    58,   118,    28,    29,    30,    46,    59,
   119,    28,    29,    30,   147,    28,    29,    30,    28,    29,
    30,   158,   156,    28,    29,    30,   171,    28,    29,    30,
   176,    28,    29,    30,    60,    61,    62,    63,    65,    66,
    67,    68,    69,    70,   110,   120,   121,   126,   127,   128,
   129,   130,   131,   134,   177,   135,   136,   137,   140,   141,
   142,   143,   125,     0,   144,   145,   146,   149,   150,   151,
   152,   153,   154,   155,   157,   159,   160,   161,   162,   163,
   164,   165,   166,   167,   168,   169,   170,   172,   173,   174,
   175,   178,   180
};

static const short yycheck[] = {     3,
     4,     1,     1,     7,     8,     9,     5,     0,    81,    13,
     3,     1,     1,     3,     7,     8,     5,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,   101,     1,
     1,     3,     4,     5,     6,     1,     3,     3,     1,    43,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,     3,     1,     1,     1,     7,     8,
     3,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,     1,     3,     3,     4,     5,     6,     1,     3,
     3,     4,     5,     6,     1,     3,     1,     4,     5,     6,
     1,     3,     1,     4,     5,     6,     1,     3,     1,     4,
     5,     6,     1,     3,     1,     4,     5,     6,     1,     3,
     1,     4,     5,     6,     3,     4,     5,     6,     4,     5,
     6,   125,     3,     4,     5,     6,     3,     4,     5,     6,
     3,     4,     5,     6,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,   158,     1,     1,     1,     1,     1,
     1,     1,    82,    -1,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     0
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
#line 176 "sksiteconfig_parse.y"
{ do_err_args("class"); ;
    break;}
case 10:
#line 187 "sksiteconfig_parse.y"
{ do_err_args("group"); ;
    break;}
case 28:
#line 224 "sksiteconfig_parse.y"
{ do_err_ctx("top level", "end class"); ;
    break;}
case 29:
#line 225 "sksiteconfig_parse.y"
{ do_err_ctx("top level", "end group"); ;
    break;}
case 30:
#line 226 "sksiteconfig_parse.y"
{ do_err_ctx("top level", "sensors"); ;
    break;}
case 31:
#line 227 "sksiteconfig_parse.y"
{ do_err_ctx("top level", "type"); ;
    break;}
case 32:
#line 228 "sksiteconfig_parse.y"
{ do_err("unknown command '%s'", yyvsp[-2].str);
				    free(yyvsp[-2].str); ;
    break;}
case 33:
#line 230 "sksiteconfig_parse.y"
{ do_err("unrecognizable command"); ;
    break;}
case 34:
#line 234 "sksiteconfig_parse.y"
{ do_err_ctx("group", "class"); ;
    break;}
case 35:
#line 235 "sksiteconfig_parse.y"
{ do_err_ctx("group", "default-class"); ;
    break;}
case 36:
#line 236 "sksiteconfig_parse.y"
{ do_err_ctx("group", "end class"); ;
    break;}
case 37:
#line 237 "sksiteconfig_parse.y"
{ do_err_ctx("group", "group"); ;
    break;}
case 38:
#line 238 "sksiteconfig_parse.y"
{ do_err_ctx("group", "include"); ;
    break;}
case 39:
#line 239 "sksiteconfig_parse.y"
{ do_err_ctx("group", "path-format"); ;
    break;}
case 40:
#line 240 "sksiteconfig_parse.y"
{ do_err_ctx("group", "sensor"); ;
    break;}
case 41:
#line 241 "sksiteconfig_parse.y"
{ do_err_ctx("group", "type"); ;
    break;}
case 42:
#line 242 "sksiteconfig_parse.y"
{ do_err_ctx("group", "version"); ;
    break;}
case 43:
#line 243 "sksiteconfig_parse.y"
{ do_err("unknown command '%s'", yyvsp[-2].str);
				    free(yyvsp[-2].str); ;
    break;}
case 44:
#line 245 "sksiteconfig_parse.y"
{ do_err("unrecognizable command"); ;
    break;}
case 45:
#line 249 "sksiteconfig_parse.y"
{ do_err_ctx("class", "class"); ;
    break;}
case 46:
#line 250 "sksiteconfig_parse.y"
{ do_err_ctx("class", "default-class"); ;
    break;}
case 47:
#line 251 "sksiteconfig_parse.y"
{ do_err_ctx("class", "end group"); ;
    break;}
case 48:
#line 252 "sksiteconfig_parse.y"
{ do_err_ctx("class", "group"); ;
    break;}
case 49:
#line 253 "sksiteconfig_parse.y"
{ do_err_ctx("class", "include"); ;
    break;}
case 50:
#line 254 "sksiteconfig_parse.y"
{ do_err_ctx("class", "path-format"); ;
    break;}
case 51:
#line 255 "sksiteconfig_parse.y"
{ do_err_ctx("class", "sensor"); ;
    break;}
case 52:
#line 256 "sksiteconfig_parse.y"
{ do_err_ctx("class", "version"); ;
    break;}
case 53:
#line 257 "sksiteconfig_parse.y"
{ do_err("unknown command '%s'", yyvsp[-2].str); ;
    break;}
case 54:
#line 258 "sksiteconfig_parse.y"
{ do_err("unrecognizable command"); ;
    break;}
case 55:
#line 262 "sksiteconfig_parse.y"
{ do_class(yyvsp[-1].str); ;
    break;}
case 56:
#line 268 "sksiteconfig_parse.y"
{ do_default_class(yyvsp[-1].str); ;
    break;}
case 57:
#line 272 "sksiteconfig_parse.y"
{ do_group(yyvsp[-1].str); ;
    break;}
case 58:
#line 278 "sksiteconfig_parse.y"
{ do_include(yyvsp[-1].str); ;
    break;}
case 59:
#line 279 "sksiteconfig_parse.y"
{ do_err_args("include"); ;
    break;}
case 60:
#line 283 "sksiteconfig_parse.y"
{ do_path_format(yyvsp[-1].str); ;
    break;}
case 61:
#line 284 "sksiteconfig_parse.y"
{ do_err_args("path-format"); ;
    break;}
case 62:
#line 288 "sksiteconfig_parse.y"
{ do_sensor(yyvsp[-2].integer, yyvsp[-1].str); ;
    break;}
case 63:
#line 289 "sksiteconfig_parse.y"
{ do_err_args("sensor"); ;
    break;}
case 64:
#line 293 "sksiteconfig_parse.y"
{ do_version(yyvsp[-1].str); ;
    break;}
case 65:
#line 294 "sksiteconfig_parse.y"
{ do_err_args("version"); ;
    break;}
case 66:
#line 298 "sksiteconfig_parse.y"
{ do_group_sensors(yyvsp[-1].str_list); ;
    break;}
case 67:
#line 299 "sksiteconfig_parse.y"
{ do_err_args("sensors"); ;
    break;}
case 68:
#line 303 "sksiteconfig_parse.y"
{ do_end_group(); ;
    break;}
case 69:
#line 304 "sksiteconfig_parse.y"
{ do_err_args_none("end group"); ;
    break;}
case 70:
#line 308 "sksiteconfig_parse.y"
{ do_class_default_types(yyvsp[-1].str_list); ;
    break;}
case 71:
#line 309 "sksiteconfig_parse.y"
{ do_err_args("default-types"); ;
    break;}
case 72:
#line 313 "sksiteconfig_parse.y"
{ do_class_sensors(yyvsp[-1].str_list); ;
    break;}
case 73:
#line 314 "sksiteconfig_parse.y"
{ do_err_args("sensors"); ;
    break;}
case 74:
#line 318 "sksiteconfig_parse.y"
{ do_class_type(yyvsp[-2].integer, yyvsp[-1].str, NULL); ;
    break;}
case 75:
#line 319 "sksiteconfig_parse.y"
{ do_class_type(yyvsp[-3].integer, yyvsp[-2].str, yyvsp[-1].str); ;
    break;}
case 76:
#line 320 "sksiteconfig_parse.y"
{ do_err_args("type"); ;
    break;}
case 77:
#line 324 "sksiteconfig_parse.y"
{ do_end_class(); ;
    break;}
case 78:
#line 325 "sksiteconfig_parse.y"
{ do_err_args_none("end class"); ;
    break;}
case 79:
#line 330 "sksiteconfig_parse.y"
{ yyval.integer = atoi(yyvsp[0].str); free(yyvsp[0].str); ;
    break;}
case 83:
#line 342 "sksiteconfig_parse.y"
{ yyval.str_list = skVectorNew(sizeof(char*)); ;
    break;}
case 84:
#line 343 "sksiteconfig_parse.y"
{ skVectorAppendValue(yyvsp[-1].str_list, &yyvsp[0].str); yyval.str_list = yyvsp[-1].str_list; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 346 "sksiteconfig_parse.y"


/* SUPPORTING CODE */

int yyerror(char UNUSED(*s))
{
    /* do nothing, we handle error messages ourselves */
    return 0;
}

/* Handle config file version */
static void do_version(char *str)
{
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "version \"%s\"\n", str);
    }
    if ( strcmp(str, "1") != 0 ) {
        sksiteconfigErr("unrecognized version '%s'", str);
    }
    free(str);
}

/* Define sensor */
static void do_sensor(int id, char *name)
{
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "sensor %d \"%s\"\n", id, name);
    }
    if ( sksiteSensorExists(id) ) {
        sksiteconfigErr("sensor with id '%d' already exists", id);
    } else if ( sksiteSensorLookup(name) != SK_INVALID_SENSOR ) {
        sksiteconfigErr("sensor with name '%s' already exists", name);
    } else if ( sksiteSensorCreate(id, name) ) {
        sksiteconfigErr("failed to create sensor");
    }
    free(name);
}

/* Define path-format */
static void do_path_format(char *fmt)
{
    int len;
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "format \"%s\"\n", fmt);
    }
    len = strlen(fmt);
    if ( (fmt[len-2] != '%') || (fmt[len-1] != 'x') ) {
        sksiteconfigErr("path-format '%s' does not end with '%%x'", fmt);
    }
    if ( sksiteSetPathFormat(fmt) ) {
        sksiteconfigErr("failed to set path format");
    }
    free(fmt);
}

/* Include a file */
static void do_include(char *filename)
{
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "include \"%s\"\n", filename);
    }
    sksiteconfigIncludePush(filename);
}

/* Begin defining a group */
static void do_group(char *groupname)
{
    assert(current_group == NULL);
    assert(current_class == NULL);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "group \"%s\"\n", groupname);
    }
    current_group = groupname;
    current_group_id = sksiteSensorgroupLookup(current_group);
    if ( current_group_id == SK_INVALID_SENSORGROUP ) {
        current_group_id = sksiteSensorgroupGetMaxID() + 1;
        if ( sksiteSensorgroupCreate(current_group_id, groupname) ) {
            current_group_id = SK_INVALID_SENSORGROUP;
            sksiteconfigErr("failed to create sensorgroup");
        }
    }
}

/* Add sensors to a group definition */
static void do_group_sensors(sk_vector_t *sensors)
{
    int i;
    int len;
    char *str;
    sensorID_t sensor_id;
    sensorgroupID_t sensorgroup_id;
    assert(current_group != NULL);
    assert(current_class == NULL);
    len = skVectorGetCount(sensors);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "[group \"%s\"] sensors", current_group);
        for ( i = 0; i < len; i++ ) {
            skVectorGetValue(&str, sensors, i);
            fprintf(stderr, " %s", str);
        }
        fprintf(stderr, "\n");
    }
    if ( current_group_id != SK_INVALID_SENSORGROUP ) {
        for ( i = 0; i < len; i++ ) {
            skVectorGetValue(&str, sensors, i);
            if ( str[0] == '@' ) {
                sensorgroup_id = sksiteSensorgroupLookup(&str[1]);
                if ( sensorgroup_id == SK_INVALID_SENSORGROUP ) {
                    sksiteconfigErr("unknown group '%s'", str);
                } else {
                    sksiteSensorgroupAddSensorgroup(current_group_id,
                                                    sensorgroup_id);
                }
            } else {
                sensor_id = sksiteSensorLookup(str);
                if ( sensor_id == SK_INVALID_SENSOR ) {
                    sksiteconfigErr("unknown sensor '%s'", str);
                } else {
                    sksiteSensorgroupAddSensor(current_group_id, sensor_id);
                }
            }
        }
    }
    /* free the vector and its contents */
    for (i = 0; i < len; ++i) {
        skVectorGetValue(&str, sensors, i);
        free(str);
    }
    skVectorDestroy(sensors);
}

/* Finish defining a group */
static void do_end_group(void)
{
    assert(current_group != NULL);
    assert(current_class == NULL);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "[group \"%s\"] end group\n", current_group);
    }
    free(current_group);
    current_group = NULL;
}

/* Begin defining a class */
static void do_class(char *classname)
{
    assert(current_group == NULL);
    assert(current_class == NULL);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "class \"%s\"\n", classname);
    }
    current_class = classname;
    current_class_id = sksiteClassLookup(current_class);
    /* We're okay on "duplicates": just more info on existing class */
    if ( current_class_id == SK_INVALID_CLASS ) {
        current_class_id = sksiteClassGetMaxID() + 1;
        if ( sksiteClassCreate(current_class_id, classname) ) {
            current_class_id = SK_INVALID_CLASS;
            sksiteconfigErr("failed to create class");
        }
    }
}

/* Add sensors to a class definition */
static void do_class_sensors(sk_vector_t *sensors)
{
    int i;
    int len;
    char *str;
    sensorID_t sensor_id;
    sensorgroupID_t sensorgroup_id;
    assert(current_class != NULL);
    assert(current_group == NULL);
    len = skVectorGetCount(sensors);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "[class \"%s\"] sensors", current_class);
        for ( i = 0; i < len; i++ ) {
            skVectorGetValue(&str, sensors, i);
            fprintf(stderr, " %s", str);
        }
        fprintf(stderr, "\n");
    }
    if ( current_class_id != SK_INVALID_CLASS ) {
        for ( i = 0; i < len; i++ ) {
            skVectorGetValue(&str, sensors, i);
            if ( str[0] == '@' ) {
                sensorgroup_id = sksiteSensorgroupLookup(&str[1]);
                if ( sensorgroup_id == SK_INVALID_SENSORGROUP ) {
                    sksiteconfigErr("unknown group '%s'", str);
                } else {
                    sksiteClassAddSensorgroup(current_class_id,
                                              sensorgroup_id);
                }
            } else {
                sensor_id = sksiteSensorLookup(str);
                if ( sensor_id == SK_INVALID_SENSOR ) {
                    sksiteconfigErr("unknown sensor '%s'", str);
                } else {
                    sksiteClassAddSensor(current_class_id, sensor_id);
                }
            }
        }
    }
    /* free the vector and its contents */
    for (i = 0; i < len; ++i) {
        skVectorGetValue(&str, sensors, i);
        free(str);
    }
    skVectorDestroy(sensors);
}

/* Define type within a class definition */
static void do_class_type(int id, char *type, char *name)
{
    char flowtype_name_buf[SK_MAX_STRLEN_FLOWTYPE+1];
    assert(current_class != NULL);
    if ( name == NULL ) {
        if ( snprintf(flowtype_name_buf, SK_MAX_STRLEN_FLOWTYPE,
                      "%s%s", current_class, type)
             > SK_MAX_STRLEN_FLOWTYPE ) {
            sksiteconfigErr("type prefix too long");
        }
        name = flowtype_name_buf;
    }
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "[class \"%s\"] type %d %s %s", current_class,
                id, type, name);
        fprintf(stderr, "\n");
    }
    if ( current_class_id != SK_INVALID_CLASS ) {
        if ( sksiteFlowtypeExists(id) ) {
            sksiteconfigErr("type with id '%d' already exists", id);
        } else if ( sksiteFlowtypeLookup(name) != SK_INVALID_FLOWTYPE ) {
            sksiteconfigErr("type with prefix '%s' already exists", name);
        } else if ( sksiteFlowtypeLookupByClassType(current_class_id, type)
                    != SK_INVALID_CLASS ) {
            sksiteconfigErr("type '%s' for class '%s' already exists",
                            type, current_class);
        } else if ( sksiteFlowtypeCreate(id, name, current_class_id, type) ) {
            sksiteconfigErr("failed to create type");
        }
    }
    free(type);
    if (name != flowtype_name_buf) {
        free(name);
    }
}

/* Set the default types within a class definition */
static void do_class_default_types(sk_vector_t *types)
{
    int i;
    int len;
    char *str;
    flowtypeID_t flowtype_id;
    assert(current_class != NULL);
    assert(current_group == NULL);
    len = skVectorGetCount(types);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "[class \"%s\"] default-types", current_class);
        for ( i = 0; i < len; i++ ) {
            skVectorGetValue(&str, types, i);
            fprintf(stderr, " %s", str);
        }
        fprintf(stderr, "\n");
    }
    if ( current_class_id != SK_INVALID_CLASS ) {
        for ( i = 0; i < len; i++ ) {
            skVectorGetValue(&str, types, i);
            flowtype_id =
                sksiteFlowtypeLookupByClassType(current_class_id, str);
            if ( flowtype_id == SK_INVALID_FLOWTYPE ) {
                sksiteconfigErr("unknown type '%s' in class '%s'",
                                str, current_class);
            } else {
                if ( sksiteClassAddDefaultFlowtype(current_class_id,
                                                   flowtype_id) ) {
                    sksiteconfigErr("failed to add default type");
                }
            }
        }
    }
    /* free the vector and its contents */
    for (i = 0; i < len; ++i) {
        skVectorGetValue(&str, types, i);
        free(str);
    }
    skVectorDestroy(types);
}

/* Finish defining a class */
static void do_end_class(void)
{
    assert(current_class != NULL);
    assert(current_group == NULL);
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "[class \"%s\"] end class\n", current_class);
    }
    free(current_class);
    current_class = NULL;
}

static void do_default_class(char *name)
{
    classID_t class_id;
    if ( sksiteconfig_testing ) {
        fprintf(stderr, "default-class \"%s\"\n", name);
    }
    class_id = sksiteClassLookup(name);
    if ( class_id == SK_INVALID_CLASS ) {
        sksiteconfigErr("undefined class '%s'", name);
    } else {
        if ( sksiteClassSetDefault(class_id) ) {
            sksiteconfigErr("failed to set default class");
        }
    }
    free(name);
}

/* Report a context error, like trying to define a sensor in a class */
static void do_err_ctx(const char *ctx, const char *cmd)
{
    do_err("command '%s' not allowed in %s", cmd, ctx);
}

/* Report an argument error: too many, too few, or the wrong args */
static void do_err_args(const char *cmd)
{
    do_err("bad arguments to command '%s'", cmd);
}

/* Report an argument error: shouldn't be any arguments */
static void do_err_args_none(const char *cmd)
{
    do_err("command '%s' does take arguments", cmd);
}


/*
** Local variables:
** mode:c
** indent-tabs-mode:nil
** c-basic-offset:4
** End:
*/
