
/*  A Bison parser, made from /Users/mthomas/.tmp/silktools-0.11.2/src/rwfilter/cfg_parser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	SENSOR_GROUP_T	257
#define	FLOWLABEL_GROUP_T	258
#define	DATERANGE_GROUP_T	259
#define	PATH_GROUP_T	260
#define	PARTITION_GROUP_T	261
#define	DOMAIN_T	262
#define	PROPERTY_T	263
#define	BEFORE_T	264
#define	AFTER_T	265
#define	WITH_T	266
#define	TO_T	267
#define	EQUALS	268
#define	SEMICOLON	269
#define	COLON	270
#define	DOLLAR	271
#define	COMMA	272
#define	PERIOD	273
#define	OPENBRACE	274
#define	CLOSEBRACE	275
#define	OPENBRACKET	276
#define	CLOSEBRACKET	277
#define	ID	278
#define	DATE	279

#line 1 "cfg_parser.y"

/*
** Copyright (C) 2004-2007 by Carnegie Mellon University.
**
** @OPENSOURCE_HEADER_START@
**
** Use of the SILK system and related source code is subject to the terms
** of the following licenses:
**
** GNU Public License (GPL) Rights pursuant to Version 2, June 1991
** Government Purpose License Rights (GPLR) pursuant to DFARS 252.225-7013
**
** NO WARRANTY
**
** ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER
** PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON UNIVERSITY
** PURSUANT TO THIS LICENSE (HEREINAFTER THE "DELIVERABLES") ARE ON AN
** "AS-IS" BASIS. CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY
** KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT
** LIMITED TO, WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE,
** MERCHANTABILITY, INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE
** OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT,
** SPECIAL OR CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY
** TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE, REGARDLESS OF
** WHETHER SUCH PARTY WAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES.
** LICENSEE AGREES THAT IT WILL NOT MAKE ANY WARRANTY ON BEHALF OF
** CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON
** CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED WITH THE
** DELIVERABLES UNDER THIS LICENSE.
**
** Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie
** Mellon University, its trustees, officers, employees, and agents from
** all claims or demands made against them (and any related losses,
** expenses, or attorney's fees) arising out of, or relating to Licensee's
** and/or its sub licensees' negligent use or willful misuse of or
** negligent conduct or willful misconduct regarding the Software,
** facilities, or other rights or assistance granted by Carnegie Mellon
** University under this License, including, but not limited to, any
** claims of product liability, personal injury, death, damage to
** property, or violation of any laws or regulations.
**
** Carnegie Mellon University Software Engineering Institute authored
** documents are sponsored by the U.S. Department of Defense under
** Contract F19628-00-C-0003. Carnegie Mellon University retains
** copyrights in all material produced under this contract. The U.S.
** Government retains a non-exclusive, royalty-free license to publish or
** reproduce these documents, or allow others to do so, for U.S.
** Government purposes only pursuant to the copyright license under the
** contract clause at 252.227.7013.
**
** @OPENSOURCE_HEADER_END@
*/

/*
**  Parser data for config file parser
**
**  Sep 2004  Dave Svoboda
**
*/

#include "silk.h"

RCSIDENT("$SiLK: cfg_parser.y 7345 2007-05-30 20:39:09Z mthomas $");

#include "utils.h"
#include "cfg_lexer.h"
#include "cfg_config.h"


/* The current config structure we should add stuff to. */
static cfg_config_t *current_config = NULL;

/* The current domain we should add stuff to; part of the current config */
static cfg_map_t *current_domain = NULL;

/* Function to use for reporting errors */
static cfg_printf_function_t cfg_default_printf_function;

/* Set during grammar parsing */
static cfg_err_t cfg_yerrno;

/* Set of variables (only used to see what's been defined */
static cfg_map_t *cfg_vars_map = NULL;


/* Macros that wrap C functions around our own error recovery code */

/* Put two parens (( )) around your fprintf args in this call */
#define CFG_YPRINTF( args)                                      \
    if (0 > cfg_default_printf_function args) {                 \
        fprintf( stderr, "Error in reporting grammar error\n"); \
        cfg_yerrno = CFG_OUTPUT_ERROR;                          \
    }

/* Var must be previously declared to be a type*. */
#define CFG_YALLOCATE( type, var, degree)                     \
    var = CFG_CAST( type, MALLOC( (degree) * sizeof( type))); \
    if (NULL == var) {                                        \
        CFG_YPRINTF(( cfg_error_msg( CFG_OUT_OF_MEMORY)));    \
        cfg_yerrno = CFG_OUT_OF_MEMORY;                       \
    }

/* Sets cfg_yerrno if procedure returns an error */
#define CFG_YCHECK( procedure)                                          \
    {                                                                   \
        int err = CFG_OK;                                               \
        if (CFG_OK != (err = (procedure))) {                            \
            CFG_YPRINTF(( "Grammar Error: %s\n", cfg_error_msg( err))); \
            cfg_yerrno = err;                                           \
        }                                                               \
    }

/** YACC requires us to declare these fns here, but define them after
    grammar **/

static void cfg_map_add_from_grammar(
    cfg_map_t      *map,
    char           *key,
    cfg_array_t    *value,
    const char     *label);


static void cfg_map_variable_values(
    cfg_array_t               **result,
    const cfg_map_t            *map,
    const char                 *key,
    const char                 *label,
    const cfg_clone_function_t  clone_function);


static void cfg_path_cross_product(
    cfg_array_t       **result,
    const cfg_array_t  *sensors,
    const cfg_array_t  *flowlabels,
    cfg_array_t        *dateranges);


cfg_err_t cfg_config_read(
    cfg_config_t               *x,
    FILE                       *input,
    const cfg_printf_function_t error_fn);



#line 145 "cfg_parser.y"
typedef union {
    char *string;
    cfg_array_t *array;
    cfg_date_t *date;
    cfg_daterange_t *daterange;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		107
#define	YYFLAG		-32768
#define	YYNTBASE	26

#define YYTRANSLATE(x) ((unsigned)(x) <= 279 ? yytranslate[x] : 56)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     8,    10,    12,    14,    16,    22,
    25,    27,    31,    33,    37,    39,    41,    43,    49,    52,
    54,    58,    60,    64,    66,    68,    70,    75,    77,    81,
    83,    86,    92,    97,    99,   103,   105,   109,   111,   115,
   120,   125,   131,   134,   136,   140,   142,   146,   148,   150,
   154,   157,   160
};

static const short yyrhs[] = {    -1,
    27,    26,     0,    28,     0,    34,     0,    48,     0,    49,
     0,    40,     0,     1,     0,     4,    29,    14,    30,    15,
     0,    17,    24,     0,    32,     0,    20,    31,    21,     0,
    32,     0,    32,    18,    31,     0,    29,     0,    33,     0,
    24,     0,     3,    35,    14,    36,    15,     0,    17,    24,
     0,    38,     0,    20,    37,    21,     0,    38,     0,    38,
    18,    37,     0,    35,     0,    39,     0,    24,     0,     8,
    24,    41,    15,     0,    43,     0,    20,    42,    21,     0,
    41,     0,    41,    42,     0,     6,    44,    14,    45,    15,
     0,    17,    24,    16,    24,     0,    47,     0,    20,    46,
    21,     0,    47,     0,    47,    18,    46,     0,    44,     0,
    36,    19,    30,     0,    36,    19,    30,    51,     0,     9,
    24,    24,    15,     0,     5,    50,    14,    51,    15,     0,
    17,    24,     0,    53,     0,    20,    52,    21,     0,    53,
     0,    53,    18,    52,     0,    50,     0,    54,     0,    55,
    13,    55,     0,    10,    55,     0,    11,    55,     0,    25,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   185,   186,   195,   196,   197,   198,   199,   204,   211,   218,
   224,   225,   231,   232,   239,   245,   251,   256,   263,   269,
   270,   276,   277,   284,   290,   296,   301,   309,   310,   314,
   315,   319,   328,   345,   346,   352,   353,   360,   365,   371,
   381,   389,   396,   402,   403,   409,   410,   417,   423,   429,
   434,   439,   444
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","SENSOR_GROUP_T",
"FLOWLABEL_GROUP_T","DATERANGE_GROUP_T","PATH_GROUP_T","PARTITION_GROUP_T","DOMAIN_T",
"PROPERTY_T","BEFORE_T","AFTER_T","WITH_T","TO_T","EQUALS","SEMICOLON","COLON",
"DOLLAR","COMMA","PERIOD","OPENBRACE","CLOSEBRACE","OPENBRACKET","CLOSEBRACKET",
"ID","DATE","input","decl","flowlabel_decl","flowlabel_var","flowlabel_set",
"flowlabel_entries","flowlabel_entry","flowlabel","sensor_decl","sensor_var",
"sensor_set","sensor_entries","sensor_entry","sensor","domain_decl","path_decl_set",
"path_decl_set2","path_decl","path_var","path_set","path_entries","path_entry",
"property_decl","daterange_decl","daterange_var","daterange_set","daterange_entries",
"daterange_entry","daterange","date", NULL
};
#endif

static const short yyr1[] = {     0,
    26,    26,    27,    27,    27,    27,    27,    27,    28,    29,
    30,    30,    31,    31,    32,    32,    33,    34,    35,    36,
    36,    37,    37,    38,    38,    39,    40,    41,    41,    42,
    42,    43,    44,    45,    45,    46,    46,    47,    47,    47,
    48,    49,    50,    51,    51,    52,    52,    53,    53,    54,
    54,    54,    55
};

static const short yyr2[] = {     0,
     0,     2,     1,     1,     1,     1,     1,     1,     5,     2,
     1,     3,     1,     3,     1,     1,     1,     5,     2,     1,
     3,     1,     3,     1,     1,     1,     4,     1,     3,     1,
     2,     5,     4,     1,     3,     1,     3,     1,     3,     4,
     4,     5,     2,     1,     3,     1,     3,     1,     1,     3,
     2,     2,     1
};

static const short yydefact[] = {     0,
     8,     0,     0,     0,     0,     0,     0,     3,     4,     7,
     5,     6,     0,     0,     0,     0,     0,     0,     0,     0,
     2,    19,     0,    10,     0,    43,     0,     0,     0,     0,
    28,     0,     0,    26,    24,     0,    20,    25,     0,    17,
    15,     0,    11,    16,     0,     0,     0,    53,    48,     0,
    44,    49,     0,     0,     0,    30,     0,    27,    41,     0,
    22,    18,     0,    13,     9,    51,    52,     0,    46,    42,
     0,     0,     0,    31,    29,    21,     0,    12,     0,    45,
     0,    50,     0,     0,     0,     0,    38,     0,    34,    23,
    14,    47,    33,    19,    20,     0,    36,     0,    32,    35,
     0,    39,    37,    40,     0,     0,     0
};

static const short yydefgoto[] = {    21,
     7,     8,    41,    42,    63,    43,    44,     9,    35,    86,
    60,    37,    38,    10,    56,    57,    31,    87,    88,    96,
    97,    11,    12,    49,    50,    68,    51,    52,    53
};

static const short yypact[] = {    30,
-32768,    -6,    -1,    11,     8,    13,    30,-32768,-32768,-32768,
-32768,-32768,    24,    36,    27,    40,    31,    42,     3,    33,
-32768,-32768,    -7,-32768,     1,-32768,    -5,    41,     3,    44,
-32768,    45,     2,-32768,-32768,    46,-32768,-32768,    29,-32768,
-32768,    47,-32768,-32768,    38,    38,    -3,-32768,-32768,    49,
-32768,-32768,    52,    43,    54,     3,    48,-32768,-32768,    50,
    55,-32768,    51,    56,-32768,-32768,-32768,    57,    58,-32768,
    38,    59,    23,-32768,-32768,-32768,     2,-32768,    29,-32768,
    -3,-32768,    53,    60,    25,    61,-32768,    64,-32768,-32768,
-32768,-32768,-32768,    59,     6,    62,    63,     1,-32768,-32768,
    25,    -5,-32768,-32768,    66,    70,-32768
};

static const short yypgoto[] = {    82,
-32768,-32768,    83,   -13,     9,   -38,-32768,-32768,    85,    67,
    12,   -33,-32768,-32768,    72,    37,-32768,    68,-32768,    -9,
    21,-32768,-32768,    91,    -4,    16,   -45,-32768,   -42
};


#define	YYLAST		98


static const short yytable[] = {    61,
    64,    69,    66,    67,    45,    46,    45,    46,    28,    13,
    13,    17,    33,    17,    47,    15,    34,    15,    13,    48,
    39,    48,    29,    77,    40,    34,   -22,    17,    82,    -1,
     1,    19,     2,     3,     4,    69,    20,     5,     6,    84,
    64,    84,    85,    61,    33,    15,    34,    22,    34,    23,
    24,    95,    40,    25,    26,    27,    32,    54,    58,    59,
    62,    65,    48,    70,    71,   106,    72,    73,    75,   107,
    76,    78,    77,    79,    83,    81,    93,    80,    99,    98,
   101,   105,   100,    94,   102,    16,    14,    91,    90,    36,
    30,   103,    74,    89,    18,    55,    92,   104
};

static const short yycheck[] = {    33,
    39,    47,    45,    46,    10,    11,    10,    11,     6,    17,
    17,    17,    20,    17,    20,    17,    24,    17,    17,    25,
    20,    25,    20,    18,    24,    24,    21,    17,    71,     0,
     1,    24,     3,     4,     5,    81,    24,     8,     9,    17,
    79,    17,    20,    77,    20,    17,    24,    24,    24,    14,
    24,    85,    24,    14,    24,    14,    24,    17,    15,    15,
    15,    15,    25,    15,    13,     0,    24,    14,    21,     0,
    21,    21,    18,    18,    16,    18,    24,    21,    15,    19,
    18,     0,    21,    24,    98,     3,     2,    79,    77,    23,
    19,   101,    56,    73,     4,    28,    81,   102
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 8:
#line 205 "cfg_parser.y"
{
    CFG_YPRINTF(( "Line %d: Syntax Error\n", cfg_lex_line_number));
    if (CFG_OK == cfg_yerrno) {cfg_yerrno = CFG_INVALID_INPUT;};
;
    break;}
case 9:
#line 212 "cfg_parser.y"
{
    cfg_map_add_from_grammar( cfg_get_config_flowlabels( current_config),
                              yyvsp[-3].string, yyvsp[-1].array, "Flowlabel");
;
    break;}
case 10:
#line 219 "cfg_parser.y"
{
    yyval.string = yyvsp[0].string;
;
    break;}
case 12:
#line 226 "cfg_parser.y"
{
    yyval.array = yyvsp[-1].array;
;
    break;}
case 14:
#line 233 "cfg_parser.y"
{
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
;
    break;}
case 15:
#line 240 "cfg_parser.y"
{
    cfg_map_variable_values( &yyval.array, cfg_get_config_flowlabels( current_config),
                             yyvsp[0].string, "Flowlabel", cfg_string_clone);
    FREE(yyvsp[0].string);
;
    break;}
case 16:
#line 246 "cfg_parser.y"
{
    CFG_YCHECK( cfg_array_create_singleton( &yyval.array, yyvsp[0].string));
;
    break;}
case 18:
#line 257 "cfg_parser.y"
{
    cfg_map_add_from_grammar( cfg_get_config_sensors( current_config),
                              yyvsp[-3].string, yyvsp[-1].array, "Sensor");
;
    break;}
case 19:
#line 264 "cfg_parser.y"
{
    yyval.string = yyvsp[0].string;
;
    break;}
case 21:
#line 271 "cfg_parser.y"
{
    yyval.array = yyvsp[-1].array;
;
    break;}
case 23:
#line 278 "cfg_parser.y"
{
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
;
    break;}
case 24:
#line 285 "cfg_parser.y"
{
    cfg_map_variable_values( &yyval.array, cfg_get_config_sensors( current_config),
                             yyvsp[0].string, "Sensor", cfg_string_clone);
    FREE(yyvsp[0].string);
;
    break;}
case 25:
#line 291 "cfg_parser.y"
{
    CFG_YCHECK( cfg_array_create_singleton( &yyval.array, yyvsp[0].string));
;
    break;}
case 27:
#line 302 "cfg_parser.y"
{
    cfg_map_add_from_grammar( cfg_get_config_domains(current_config),
                              yyvsp[-2].string, CFG_CAST( cfg_array_t, current_domain),
                              "Domain");
    current_domain = NULL;
;
    break;}
case 32:
#line 320 "cfg_parser.y"
{
    if (current_domain == NULL) {
        CFG_YCHECK( cfg_map_create( &current_domain));
    }
    CFG_YCHECK( cfg_map_add( current_domain, yyvsp[-3].string, yyvsp[-1].array));
;
    break;}
case 33:
#line 329 "cfg_parser.y"
{
    /* We enforce the internal struct of a path var in the grammar,
       but once it parses, we can ignroe the internal struct, just turn
       it back into a simple string */
    int length = strlen( yyvsp[-2].string);
    char *name;
    CFG_YALLOCATE( char, name, (strlen( yyvsp[-2].string) + strlen( yyvsp[0].string) + 2));
    strcpy( name, yyvsp[-2].string);
    strcpy(name + length, ":");
    strcpy(name + length + 1, yyvsp[0].string);
    FREE( yyvsp[-2].string);
    FREE( yyvsp[0].string);
    yyval.string = name;
;
    break;}
case 35:
#line 347 "cfg_parser.y"
{
    yyval.array = yyvsp[-1].array;
;
    break;}
case 37:
#line 354 "cfg_parser.y"
{
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
;
    break;}
case 38:
#line 361 "cfg_parser.y"
{
    cfg_map_variable_values( &yyval.array, current_domain, yyvsp[0].string, "Path", cfg_path_clone);
    FREE(yyvsp[0].string);
;
    break;}
case 39:
#line 366 "cfg_parser.y"
{
    cfg_path_cross_product( &yyval.array, yyvsp[-2].array, yyvsp[0].array, NULL);
    cfg_array_destroy( yyvsp[-2].array, cfg_free);
    cfg_array_destroy( yyvsp[0].array, cfg_free);
;
    break;}
case 40:
#line 372 "cfg_parser.y"
{
    cfg_path_cross_product( &yyval.array, yyvsp[-3].array, yyvsp[-1].array, yyvsp[0].array);
    cfg_array_destroy( yyvsp[-3].array, cfg_free);
    cfg_array_destroy( yyvsp[-1].array, cfg_free);
    cfg_array_destroy( yyvsp[0].array, cfg_daterange_destroy);
;
    break;}
case 41:
#line 382 "cfg_parser.y"
{
    CFG_YCHECK( cfg_map_add( cfg_get_config_properties( current_config),
                                                        yyvsp[-2].string, yyvsp[-1].string));
;
    break;}
case 42:
#line 390 "cfg_parser.y"
{
    cfg_map_add_from_grammar( cfg_get_config_dates( current_config),
                              yyvsp[-3].string, yyvsp[-1].array, "Date Range");
;
    break;}
case 43:
#line 397 "cfg_parser.y"
{
    yyval.string = yyvsp[0].string;
;
    break;}
case 45:
#line 404 "cfg_parser.y"
{
    yyval.array = yyvsp[-1].array;
;
    break;}
case 47:
#line 411 "cfg_parser.y"
{
    yyval.array = yyvsp[-2].array;
    CFG_YCHECK( cfg_array_concatenate( yyval.array, yyvsp[0].array));
;
    break;}
case 48:
#line 418 "cfg_parser.y"
{
    cfg_map_variable_values( &yyval.array, cfg_get_config_dates( current_config),
                             yyvsp[0].string, "Date Range", cfg_daterange_clone);
    FREE(yyvsp[0].string);
;
    break;}
case 49:
#line 424 "cfg_parser.y"
{
    CFG_YCHECK( cfg_array_create_singleton( &yyval.array, yyvsp[0].daterange));
;
    break;}
case 50:
#line 430 "cfg_parser.y"
{
    CFG_YCHECK( cfg_daterange_create( &yyval.daterange, yyvsp[-2].date, yyvsp[0].date));
;
    break;}
case 51:
#line 435 "cfg_parser.y"
{
    CFG_YCHECK( cfg_daterange_create_before( &yyval.daterange, yyvsp[0].date));
;
    break;}
case 52:
#line 440 "cfg_parser.y"
{
    CFG_YCHECK( cfg_daterange_create_after( &yyval.daterange, yyvsp[0].date));
;
    break;}
case 53:
#line 445 "cfg_parser.y"
{
    struct timeval tv;
    skStringParseDatetime(&tv, yyvsp[0].string, NULL);
    CFG_YCHECK( cfg_date_create( CFG_CAST_PTR( cfg_date_t, yyval.date), tv.tv_sec));
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 480 "cfg_parser.y"



/*
 * Adds declaration to proper map, printing friendly error msg if item
 * already defined.
 */
static void cfg_map_add_from_grammar(
    cfg_map_t      *map,
    char           *key,
    cfg_array_t    *value,
    const char     *label)
{
  char *key_clone;
  CFG_YALLOCATE( char, key_clone, strlen( key) + 1);
  strcpy( key_clone, key);
  if (CFG_DATA_OVERWRITTEN == cfg_map_add( map, key, value) ||
      CFG_DATA_OVERWRITTEN == cfg_map_add( cfg_vars_map, key_clone, NULL)) {
        CFG_YPRINTF(( "Line %d: %s variable $%s redefined!\n",
                      cfg_lex_line_number, label, key));
        if (CFG_OK == cfg_yerrno) {cfg_yerrno = CFG_INVALID_INPUT;};
    }
}


/*
 * Returns the value of a variable, from the appropraite map, printing
 * friendly error msg if not found. Clones variable's values, so that
 * free doesn't crash later.
 */
static void cfg_map_variable_values(
    cfg_array_t               **result,
    const cfg_map_t            *map,
    const char                 *key,
    const char                 *label,
    const cfg_clone_function_t  clone_function)
{
    cfg_array_t *values = cfg_map_assoc( map, key);
    CFG_YCHECK( cfg_array_create( result));
    if (values == NULL) {
        CFG_YPRINTF(( "Line %d: %s variable $%s is not defined!\n",
                       cfg_lex_line_number, label, key));
        if (CFG_OK == cfg_yerrno) {cfg_yerrno = CFG_INVALID_INPUT;};
    } else {
        cfg_array_t *clone;
        CFG_YCHECK( cfg_array_clone( &clone, values, clone_function));
        CFG_YCHECK( cfg_array_concatenate( *result, clone));
    }
}


/*
 * Returns an array of paths generated by combinatorially enumerating
 * the array of sensors and array of flowlabels. Dateranges just gets
 * assinged; and it may be NULL.
 */
static void cfg_path_cross_product(
    cfg_array_t       **result,
    const cfg_array_t  *sensors,
    const cfg_array_t  *flowlabels,
    cfg_array_t        *dateranges)
{
    int i, j;
    CFG_YCHECK( cfg_array_create( result));
    for (i = 0; i < cfg_get_array_length( sensors); i++) {
        for (j = 0; j < cfg_get_array_length( flowlabels); j++) {
            cfg_path_t *path;
            CFG_YCHECK( cfg_path_create( &path,
                                         cfg_get_array_element(sensors, i),
                                         cfg_get_array_element( flowlabels, j),
                                         dateranges));
            CFG_YCHECK( cfg_array_add( *result, path));
        }
    }
}


/*
 *   Parses a configuration file into a configuration struct.
 *
 *   - config must have already been created, but need not be 'empty';
 *   preexisting data in config is kept.
 *
 *   - error_fn gets called for every error in the code. You can give it
 *   NULL, in which case it defaults to printf.
 *
 *   Returns CFG_OK if file is completely valid, or
 *   CFG_INVALID_INPUT if any parse errors occurred.
 */
cfg_err_t cfg_config_read(
    cfg_config_t               *x,
    FILE                       *input,
    const cfg_printf_function_t error_fn)
{
    cfg_default_printf_function = printf;
    if (error_fn != NULL) {
        cfg_default_printf_function = error_fn;
    }
    current_config = x; /* purser puts data into current_config */
    cfg_map_create( &cfg_vars_map);
    cfg_yerrno = CFG_OK;
    yyin = input;
    yyparse();
    cfg_map_destroy( cfg_vars_map, cfg_free);
    return cfg_yerrno;
}


/* Yacc calls this function when it encounters an error */
int yyerror(char UNUSED(*s))
{
    return 0;
}

/*
** Local Variables:
** mode:c
** indent-tabs-mode:nil
** c-basic-offset:4
** End:
*/
